<?php

require_once IF_ROOT_PATH . 'model'. DS . 'client.php';

class client extends controller
{
    public $model;
    public $client;
    private $auth;
    private $client_affiche = 50;
    
    public function __construct()
    {
        $this->model = new modelClient();
        $this->getData();
        
        if( isset($this->data['client_id']) && is_numeric($this->data['client_id']) )
        {
            $this->client = $this->model->getById($this->data['client_id']);
        }
        
        $this->auth = $this->model->getAuth();
        
        $GLOBALS['smarty']->assign('auth', $this->auth);
    }
    
    public function index()
    {
        if($this->auth['voir'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?error=access_violation');
            exit;
        }
       
       /**
        * TRAITEMENT PAGINATION
        * */
       // On demande la quantit client en base 
       $nb_client = $this->model->getNbClient(); 
       
       // Nombre de page 
       $nb_page = ceil($nb_client/$this->client_affiche);
       
       /* Rcupration du numro de la page courante depuis l'URL avec la mthode GET */
	   if(!isset($this->data['p']) || !is_numeric($this->data['p']) ) // si $_GET['p'] n'existe pas OU $_GET['p'] n'est pas un nombre (petite scurit supplmentaire)
		  $current_page = 1; // la page courante devient 1
	   else
	   {
    		$page = intval($this->data['p']);                 // stockage de la valeur entire uniquement
    		if ($page < 1) $current=1;                        // cas o le numro de page est infrieure 1 : on affecte 1  la page courante
    		elseif ($page > $nb_page) $current_page=$nb_page;   //cas o le numro de page est suprieur au nombre total de pages : on affecte le numro de la dernire page  la page courante
    		else $current_page=$page;                         // sinon la page courante est bien celle indique dans l'URL
	   }
       
       // Calcul du OFFSET pour la requete
       $offset = ($current_page * $this->client_affiche - $this->client_affiche);

       // Inclusion fichier pour l affichage
       require_once IF_ROOT_PATH . 'lib'. DS .'pagination.php';

       /**
        * --- FIN PAGINATION ---
        * */
       $GLOBALS['smarty']->assign('pagination', paginate($GLOBALS['setting']['url_site'] . 'index.php?c=client', '&p=', $nb_page, $current_page) );  
       $GLOBALS['smarty']->assign('clients', $this->model->getClient($this->client_affiche,$offset,isset($this->data['orderby']) ? $this->data['orderby'] : '' ));
       
       return $GLOBALS['smarty']->fetch('client_index.tpl'); 
    }
    
    public function fiche()
    {
        //Verification que le client pass en ID est present
        if($this->client == '')
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?c=client');
            exit;
        }
        
        // Verification que l utilisateur est autoris avoir les clients.
        if($this->auth['voir'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?error=access_violation');
            exit;
        }
        
        $this->model->updateCpt($this->data['client_id']);

        $GLOBALS['smarty']->assign('client', $this->client);
        $GLOBALS['smarty']->assign('historiques', $this->model->getHistorique($this->data['client_id']));
        $GLOBALS['smarty']->assign('champSup', $this->model->getChampSup());
		$GLOBALS['smarty']->assign('commentaires', $this->model->getCommentaireByClient($this->data['client_id']) );
		$GLOBALS['smarty']->assign('fichiers', getFileInDir(IF_ROOT_PATH . 'upload' . DS . 'client' . DS . $this->data['client_id']) ); 
		$GLOBALS['smarty']->assign('rendezvous', $this->model->getRendezvousByClient($this->data['client_id']) );
        $GLOBALS['smarty']->assign('tickets', $this->model->getTicketByClient($this->data['client_id']));
        return $GLOBALS['smarty']->fetch('client_fiche.tpl');
    }
    
	public function uploadFile()
	{
		$destination = IF_ROOT_PATH . 'upload' . DS . 'client' . DS . $this->data['client_id'];
		
		$result = 0;
		
		if( !is_dir($destination) )
		{
			//Creation du dossier client
			mkdir($destination);
		}
		
		//Traitement du fichier
		
		$name = $_FILES['fichier']['name'];
		$extension = substr(strrchr($_FILES['fichier']['name'],'.'),1);
		
		//Suppression des espaces et remplacement pas un _
		$name = str_replace(' ','_',$name);
		
		//Supression des accents
		$name = strtr($name, 
          '', 
          'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
		
		// On deplace le fichier
		if(move_uploaded_file($_FILES['fichier']['tmp_name'], $destination . DS . $name)) 
		{	$result = 1;
			$this->model->addLog($this->data['client_id'], 'Fichier_ajout');
		}
		sleep(1);
			
		return '<script language="javascript" type="text/javascript">window.top.window.stopUpload('. $result .');</script>';   
	}
	
    public function add()
    {
        $cats = getClientCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['titre'];
        }
        
        // Recuperation des catgories
        $GLOBALS['smarty']->assign('categories', $categories);
        $GLOBALS['smarty']->assign('champ_supplementaire', getChampSup('client'));
        return $GLOBALS['smarty']->fetch('client_add.tpl');
    }
    
    public function save()
    {
        $data = $this->data['client'];
        //Verification arrive du formulaire
        if( !isset($this->data['send']) )
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?c=client&a=add',0);
            exit;
        }
        
        //Verification token
        $GLOBALS['session']->checkCSRFpost();        
        
        // Verification des donnes reu
        if($data['nom'] == '' && $data['societe'] == '')
        {
            return redirect($GLOBALS['setting']['url_site'].'index.php?c=client&a=add',3,$GLOBALS['lang']['Donnees_client_incomplete'].'|warning');
            exit;
        }
        
        // Enregistrement dans la base
        if( $this->model->save($data) )
        {
            return redirect($GLOBALS['setting']['url_site'].'index.php?c=client',3,$GLOBALS['lang']['Client_enregistre']);;
        }
        else
        {
            return redirect($GLOBALS['setting']['url_site'].'index.php?c=client&a=add',3,$GLOBALS['lang']['Client_erreur_enregistrement'].'|warning');
        }
    }
    
    public function modif()
    {
        if($this->auth['edit'] != 1 && $_SESSION['utilisateur']['admin']!= 1)
            exit;
            
        $cats = getClientCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['titre'];
        }
        
        $GLOBALS['smarty']->assign('client', $this->client);
        $GLOBALS['smarty']->assign('categories', $categories);
        $GLOBALS['smarty']->assign('champ_supplementaire', getChampSup('client', $this->client));
        $GLOBALS['smarty']->assign('formulaire', $GLOBALS['smarty']->fetch('formulaire_client.tpl') );
        return $GLOBALS['smarty']->fetch('client_modif.tpl');
    }
    
    public function edit()
    {
       $data = $this->data['client'];
        //Verification arrive du formulaire
        
        if($this->auth['edit'] != 1 && $_SESSION['utilisateur']['admin']!= 1)
            exit;
        
        //Verification token
        $GLOBALS['session']->checkCSRFpost();
        
        // Verification des donnes reu
        if($data['nom'] == '' && $data['societe'] == '')
            return redirect($GLOBALS['setting']['url_site'].'index.php?c=client',3,$GLOBALS['lang']['Donnees_client_incomplete'].'|warning');
        
        // Enregistrement dans la base
        if( $this->model->edit($data) )
            return redirect(URL_SITE.'index.php?c=client&a=fiche&client_id='.$data['id'].'',3,$GLOBALS['lang']['Client_modifie']);
        else
            return redirect(URL_SITE.'index.php?c=client&a=fiche&client_id='.$data['id'].'',3,$GLOBALS['lang']['Client_erreur_enregistrement'].'|warning');
    }
    
    public function delete()
    {
        // Verification jeton
        $GLOBALS['session']->checkCSRFget();
        
        // Verification droit utilisateur
        if($this->auth['del'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?error=access_violation');
            exit;
        }
        
        // Supression
        $this->model->delete($this->data['client_id']);
        
        // Redirection utilisateur
        return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=client',3,$GLOBALS['lang']['Client_supprime']);
    }
	
	public function ajaxAutoSearch()
	{
		$resultat = '';
		if( isset($this->data['queryString']) )
		{
			$queryString  =  $this->data['queryString'];
			
			if( strlen($queryString) > 0)
			{
				// Construction de la requete
				if( is_numeric($queryString) )
				{
					// Numero de telephone recherche
					$query = "SELECT id, nom, prenom, societe, telephone, fax, portable, numero_client FROM ". PREFIX ."client WHERE (telephone LIKE '%$queryString%' OR portable LIKE '%$queryString%' OR fax LIKE '%$queryString%' OR numero_client LIKE '%$queryString%') LIMIT 10";
				}
				else
					$query = "SELECT id, nom, prenom, societe, telephone, fax, portable, numero_client FROM ". PREFIX ."client WHERE (nom LIKE '%$queryString%' OR societe LIKE '%$queryString%' OR numero_client LIKE '%$queryString%') LIMIT 10";
					
				// Execution requete
				$req = $GLOBALS['db']->query($query);
				$res = $req->fetchAll();
				
				if( count($res) > 0 )
				{
					$GLOBALS['smarty']->assign('clients',$res);
					return $GLOBALS['smarty']->fetch('client_ajaxAutoSearch.tpl');
				}
				else
					return $resultat;
			}
			else
				return $resultat;
		}
		else
			return $resultat;		
	}
	
	public function ajaxReloadFichier()
	{
		$fichiers = getFileInDir(IF_ROOT_PATH . 'upload' . DS . 'client' . DS . $this->data['client_id']);
		$html = '';
		foreach($fichiers as $key => $value)
		{
			$html .= '<li><a href="'. $GLOBALS['setting']['url_site'] .'upload/client/'. $this->data['client_id'] .'/'. $value .'" title="" target="_blank"><img src="'. $GLOBALS['setting']['url_site'] .'images/Save.png" style="width:15px; height:15px;" />'. $value .'</a>';
			
			if( $_SESSION['utilisateur']['admin'] == 1)
			{
				$html .= '&nbsp;&nbsp;&nbsp;<a onclick="delfile(\''. $value .'\')" ><img src="'. $GLOBALS['setting']['url_site'] .'images/delSmall.png" style="height:15px; width:15px;"/></a>';
			}
			
			$html .= '</li>';
		}
		
		return $html;
	}
	
	public function ajaxDeleteFichier()
	{
		if( $_SESSION['utilisateur']['admin'] != 1)
			exit;
	
		if($this->data['fichier'] == '')
			return '';
			
		if(! is_file(IF_ROOT_PATH . 'upload' . DS . 'client' . DS . $this->data['client_id'] . DS . $this->data['fichier']) )
			return '';
			
		unlink(IF_ROOT_PATH . 'upload' . DS . 'client' . DS . $this->data['client_id'] . DS . $this->data['fichier']);
		
		return '';
	}
	
	public function ajaxCommentaireAjout()
	{
		if( !isset($this->data['commentaire']) || $this->data['commentaire'] == '')
			return '';
		
		$commentaire = htmlentities( $this->data['commentaire']);
		$commentaire = trim($commentaire);
		
		$this->model->saveCommentaire( array('commentaire' => $commentaire, 'client_id' => $this->data['client_id']) );
		return $this->ajaxCommentaireReload();
		
	}
	
	public function ajaxCommentaireReload()
	{
		$GLOBALS['smarty']->assign('commentaires', $this->model->getCommentaireByClient($this->data['client_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_client_fiche_CommentaireReload.tpl');
	}	
	
	public function ajaxCommentaireDelete()
	{
		// verification admin
		if( $_SESSION['utilisateur']['admin'] != 1)
			exit;
			
		//Verification jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification des donnes reu
		if( !isset($this->data['commentaire_id']) || !is_numeric($this->data['commentaire_id']) || $this->data['commentaire_id'] == '')
			exit;
		
		// Verification du client
		if($this->client == '')
			exit;
			
		// Suppression de la base
		$this->model->commentaireDelete($this->data);
		
		// On renvoie les tableaux des commentaires
		return $this->ajaxCommentaireReload();
	}
	
	public function ajaxPrintMap()
	{
		// Inclusion de class
		require_once IF_ROOT_PATH . 'lib' . DS . 'GoogleMapAPI.class.php';
		
		// Verification des donnes
		if( $this->client == '')
			exit;
		
		// On instancie la class
		$map = new GoogleMapAPI('map');
	
		// On lui indique la cle google map
		$map->setAPIKey($GLOBALS['setting']['key_google_map']);
		
		// Creation du point
		$map->addMarkerByAddress($this->client['adresse'] . ' '. $this->client['code_postal'] . ' '. $this->client['ville'] . ' '. $this->client['pays'],$this->client['nom'] .' '. $this->client['prenom'] . ' '. $this->client['societe'],'<b>'. $this->client['pays'],$this->client['nom'] .' '. $this->client['prenom'] . ' '. $this->client['societe'] .'</b>');

		// On envoie au tempalte les donnes
		$GLOBALS['smarty']->assign('HeaderJS', $map->getHeaderJS() );
		$GLOBALS['smarty']->assign('MapJS',$map->getMapJS() );
		$GLOBALS['smarty']->assign('Map',$map->getMap() );
		echo $GLOBALS['smarty']->fetch('Ajax_client_fiche_carte.tpl');
	}
	
	public function ajaxRendezvousAjout()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->client == '')
			exit;
		
		$data = array();
		
		// Recuperation et formatage des donnes
		$date = explode('/', $this->data['date']);
		$data['date_rdv'] = $date[2].'-'.$date[1].'-'.$date[0].' '. $this->data['heure'] .':'.$this->data['minute'];
		
		$data['sujet_rdv'] = addslashes(htmlentities($this->data['sujet']));
		$data['client_id'] = $this->data['client_id'];
		$data['user_id'] = $_SESSION['utilisateur_id'];
		
		$this->model->rendezvousSave($data);
		return $this->ajaxRendezvousReload();
	}
	
	public function ajaxRendezvousReload()
	{
		$GLOBALS['smarty']->assign('rendezvous', $this->model->getRendezvousByClient($this->data['client_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_client_fiche_RendezvousReload.tpl');
	}
	
	public function ajaxRendezvousDelete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->client == '')
			exit;
			
		$this->model->rendezvousDelete($this->data['rendezvous_id']);
		
		return $this->ajaxRendezvousReload();
	}
}
?>