<?php
/**
 * INFOGEST V2
 * Fichier gerant les actions d administration sur le front-end Client
 * */

// Inclusion du model
require_once IF_ROOT_PATH . 'model' . DS . 'clientAdmin.php';

class clientAdmin extends controller
{
    public $model;
    
    public function __construct()
    {
        if($_SESSION['utilisateur']['admin'] != 1)
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?access_violation');
        }
        
        $this->getData();
        $this->model = new clientAdminModel();
    }
    
    public function index()
    {
        return $GLOBALS['smarty']->fetch('clientAdmin_index.tpl');
    }
/*--- AUTHORISATION--- */    
    
    public function index_auth()
    {
        getUserSelect();
        return $GLOBALS['smarty']->fetch('clientAdmin_indexAutorisation.tpl');
    }
    
    public function ajaxShowAuth()
    {
        $authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		
		if(!$authForUser):
			$this->model->UpdateAuthByUser($this->data['utilisateur_id']);
			$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		endif;
		
		// Envoie des auth au template
		$GLOBALS['smarty']->assign('auth', $authForUser);
		
		// Affichage du template
        return $GLOBALS['smarty']->fetch('Ajax_clientAdmin_ShowAuth.tpl');
    }
	
	public function authUpdate()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( !isset($this->data['sendAuth']) ):
			redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_auth',0);
			exit;
		endif;
		
		// Collecte des donnes
		$data = array();
		
		if( !isset($this->data['voir']) )
			$data['voir'] = 0;
		else
			$data['voir'] = 1;
			
		if( !isset($this->data['ajout']) )
			$data['ajout'] = 0;
		else
			$data['ajout'] = 1;
			
		if( !isset($this->data['edit']) )
			$data['edit'] = 0;
		else
			$data['edit'] = 1;
			
		if( !isset($this->data['del']) )
			$data['del'] = 0;
		else
			$data['del'] = 1;
			
		$data['id'] = $this->data['id'];
		$data['user_id'] = $this->data['user_id'];
		
		// Envoie des donnes dans la base
		if( $this->model->updateAuth($data) )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_auth', 3, $GLOBALS['lang']['Droit_mise_a_jour']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_auth', 3, $GLOBALS['lang']['Erreur_mise_a_jour_droit'].'|warning');
	}

/*--- CATEGORIE CLIENT ---*/
	public function index_categorie()
	{
		$GLOBALS['smarty']->assign('categories',$this->model->getAllCategorie() );
		return $GLOBALS['smarty']->fetch('clientAdmin_indexCategorie.tpl');		
	}
	
	public function categorieAjout()
	{
		return $GLOBALS['smarty']->fetch('clientAdmin_categorieAjout.tpl');
	}
    
    public function categorieEdit()
    {
        // Verification que l on est bien passe une categorie id
        if( !isset($this->data['categorie_id']) || !is_numeric($this->data['categorie_id']) )
            return $GLOBALS['smarty']->fetch('clientAdmin_indexCategorie.tpl');	
        
        $GLOBALS['smarty']->assign('categorie', $this->model->getCategorieById($this->data['categorie_id']) );
        
        return $GLOBALS['smarty']->fetch('clientAdmin_categorieEdit.tpl');
    }
    
    public function categorieDelete()
    {
        $GLOBALS['session']->checkCsrfGet();
        
        if( !isset($this->data['categorie_id']) )
            redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie',0);
        
        $this->model->categorie_delete($this->data['categorie_id']);
        
        return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie', 3, $GLOBALS['lang']['Categorie_supprimee']);
    }
	
	/**
	* @desc traitement les donnes reu du formulaire
	*/
	public function saveCategorie()
	{
	   $GLOBALS['session']->checkCsrfPost();
       
	   $data = $this->data['categorie'];
       
	   // Verification des donnes reu
	   if($data['titre'] == '')
       {
            return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=categorieAjout',3,$GLOBALS['lang']['Erreur_titre_vide']);
            exit;
       }
       
       // Protection des donnes
       foreach($data as $key => $value)
       {
            $data[''. $key . ''] = addslashes($value);
       }
       
       // Entregistrement Nouvelle categorie
       if( isset($this->data['add']) )
       {
            // Traitement ajout dans la base
            if( $this->model->categorie_save($data) )
            {
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie',3,$GLOBALS['lang']['Categorie_sauvegarde']);
            }
            else
            {
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=categorieAjout',3,$GLOBALS['lang']['Erreur_enregistrement_categorie'].'|warning');
            }            
       }
       
       if( isset($this->data['edit']) )
       {
            // Verification ID categorie a editer present et numeric
            if( !isset($data['id']) || !is_numeric($data['id']) )
            {
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie', 3, $GLOBALS['lang']['Erreur_donnnee_manquante'].'|warning');
            }
            
            // Enregistrement
            if( $this->model->categorie_edit($data) )
            {
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie',3,$GLOBALS['lang']['Categorie_sauvegarde']);
            }
            else
            {
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_categorie',3,$GLOBALS['lang']['Erreur_enregistrement_categorie'].'|warning');
            }  
            
       }
       
	}
    
/*--- GESTION DU FORMULAIRE ---*/    
    function index_formulaire()
    {
        $GLOBALS['smarty']->assign('champs', $this->model->getChamp() );
        return $GLOBALS['smarty']->fetch('clientAdmin_indexFormulaire.tpl'); 
    }
    
    public function addChamp()
    {
        return $GLOBALS['smarty']->fetch('clientAdmin_addChamp.tpl');
    }
	
	public function champEdit()
	{
		$GLOBALS['smarty']->assign('champ', $this->model->getChampById($this->data['champ_id']));
		return $GLOBALS['smarty']->fetch('clientAdmin_champEdit.tpl');
	}
	
	public function champModif()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
		// Verification que la page est charger depuis le formulaire
		if( !isset($_POST['edit']) )
        {
            redirect($GLOBALS['setting']['url_site'].'index.php?c=clientAdmin&a=addChamp');
            exit;
        }
		
		// Enregistrement des modification
		if( $this->model->champ_edit($this->data['champ']) )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_modifie']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_erreur_enregistrement'].'|warning');
	}
	
	public function champDelete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		$champ = $this->model->getChampById($this->data['champ_id']);
		
		if( $this->model->champ_delete($champ) )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_supprime']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_erreur_suppression']);
	}
    
    public function saveChamp()
    {
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
        //Verification que la page est bien charger depuis le formulaire
        if( !isset($_POST['send']) )
        {
            redirect($GLOBALS['setting']['url_site'].'index.php?c=clientAdmin&a=addChamp');
            exit;
        }
        
        //Appel function pour sauvegarde
        if( $this->model->saveChamp($this->data['champ']))
        //Redirection utilisateur
        {
            return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_enregistre']);
        }
        else
        {
           return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=clientAdmin&a=index_formulaire',3,$GLOBALS['lang']['Champ_erreur_enregistrement'].'|warning');  
        }
        
    }
	
	public function preference()
	{
		return $GLOBALS['smarty']->fetch('clientAdmin_preference.tpl');
	}
}
