<?php
//--------------------------------------------//
//	INFOGEST V2
//	@Author Drouche Romain
//	@Create on 06/10/2010
//      @Last edit :
//	http://www.info-gest.fr
//	
//--------------------------------------------//
class fournisseur extends controller
{
	protected $model;
	protected $fournisseur;
        private $auth;


        public function __construct()
	{
            $this->getData();
            
            require_once IF_ROOT_PATH . 'model' . DS . 'fournisseur.php';
            $this->model = new fournisseurModel();

            if( isset($this->data['fournisseur_id']) )
                $this->fournisseur = $this->model->getById ($this->data['fournisseur_id']);


            $this->auth = $this->getAuth('auth_fournisseur');
            $GLOBALS['smarty']->assign('auth', $this->auth);

            // Verification droit voir les pages
            if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['voir'] != 1)
                redirect(URL_SITE . 'index.php');
	}
    
    /**
     * Affiche la page d'index des fournissseurs
     * */
    public function index()
    {
        $GLOBALS['smarty']->assign('fournisseurs', $this->model->getAll());
        return $GLOBALS['smarty']->fetch('fournisseur_index.tpl');
    }

    public function ajout()
    {
        if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1) redirect(URL_SITE . 'index.php?c=fournisseur');

        $GLOBALS['smarty']->assign('categories', $this->model->getCategorie() );
        return $GLOBALS['smarty']->fetch('fournisseur_ajout.tpl');
    }

    /**
     * Affiche le formulaire d edition fournisseur
     * @return <mixed> code html de la page
     */
    public function edit()
    {
        if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1) redirect(URL_SITE . 'index.php?c=fournisseur');

        if($this->fournisseur == '') redirect(URL_SITE . 'index.php?c=fournisseur');
        
        $GLOBALS['smarty']->assign('fournisseur', $this->fournisseur);          //Envoie des categories aux templates
        $GLOBALS['smarty']->assign('categories', $this->model->getCategorie() );//Envoie des donnes du fournisseur au templates
        return $GLOBALS['smarty']->fetch('fournisseur_edit.tpl');
    }
    public function fiche()
    {
        if($this->fournisseur == '')
            redirect(URL_SITE . 'index.php?c=fournisseur');

        $GLOBALS['smarty']->assign(array(
            'fournisseur'   =>  $this->fournisseur,
            'commerciaux'   =>  $this->model->getCommercialByFournisseur($this->data['fournisseur_id']),
            'produits'  =>  $this->model->getProduits($this->fournisseur['id']),
        ));
        
        return $GLOBALS['smarty']->fetch('fournisseur_fiche.tpl');
    }

    public function send()
    {
        $GLOBALS['session']->checkCsrfPost();

        $this->fournisseur = $this->data['fournisseur'];

        if($this->fournisseur['nom'] == '')
            redirect (URL_SITE . 'index.php?c=fournisseur');

        if( isset($this->data['fournisseur_add']) )
        {
            if( $this->model->add($this->fournisseur, PREFIX . 'fournisseur') )
                return redirect (URL_SITE . 'index.php?c=fournisseur', 3, $GLOBALS['lang']['Fournisseur_ajoute']);
            else
                return redirect (URL_SITE . 'index.php?c=fournisseur', 3, $GLOBALS['lang']['Erreur_enregistrement'].'|warning');
        }

        if( isset($this->data['fournisseur_edit']) )
        {
            if( $this->model->update($this->fournisseur, PREFIX . 'fournisseur') )
                return redirect (URL_SITE . 'index.php?c=fournisseur', 3, $GLOBALS['lang']['Fournisseur_modifie']);
            else
                return redirect (URL_SITE . 'index.php?c=fournisseur', 3, $GLOBALS['lang']['Erreur_enregistrement'].'|warning');
        }
    }

    public function delete()
    {
        if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['del'] != 1) redirect(URL_SITE . 'index.php?c=fournisseur');

        $GLOBALS['session']->checkCsrfGet();

        if( $this->fournisseur == '') redirect(URL_SITE . 'index.php?c=fournisseur');

        $this->model->delete($this->fournisseur['id'], PREFIX .'fournisseur');

        return redirect (URL_SITE . 'index.php?c=fournisseur', 3, $GLOBALS['lang']['Fournisseur_supprime']);
    }

    public function commercial_send()
    {
        $GLOBALS['session']->checkCsrfPost();

        $commercial = $this->data['commercial'];

        if( isset($this->data['commercial_add']) )
        {
            if($commercial['nom'] == '')
                return false;

            $this->model->add($commercial, PREFIX . 'fournisseur_commercial');
            $fournisseur_id = $commercial['fournisseur_id'];

            return '<script language="javascript" type="text/javascript">window.top.window.reloadCommercialListe();</script>';
        }
    }

    public function commercial_delete()
    {
       $GLOBALS['session']->checkCsrfGet();

       if( !isset($this->data['commercial_id']) )
            return false;

       $this->model->delete($this->data['commercial_id'], PREFIX . 'fournisseur_commercial');

       return $this->reload_commercial_liste();
    }

    public function reload_commercial_liste()
    {
        $GLOBALS['smarty']->assign('commerciaux', $this->model->getCommercialByFournisseur($this->data['fournisseur_id']));
        return $GLOBALS['smarty']->fetch('fournisseur__commercial_liste.tpl');
    }


}	
?>