<?php
require_once IF_ROOT_PATH . 'model'. DS .'mailing.php';

class mailing extends controller
{
	protected $model;
	protected $auth;
	protected $mailing;
	
	public function __construct()
	{
		$this->model = new mailingModel();
		$this->getData();
		
		if( isset($this->data['mailing_id']) )
			$this->mailing = $this->model->getById($this->data['mailing_id']);
			
		// Recuperation des droits
		$this->auth = $this->getAuth('auth_mailing');
		// Envoie des droits au template
		$GLOBALS['smarty']->assign('auth', $this->auth);
	}
	
	public function index()
	{
		$GLOBALS['smarty']->assign('mailings', $this->model->getAll() );
		return $GLOBALS['smarty']->fetch('mailing_index.tpl');
	}
	
	public function nouveau()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
			exit;
		
		$cats = getClientCategorie();
        $categories = array('0' => $GLOBALS['lang']['Toutes']);
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['titre'];
        }
        
        // Recuperation des catgories
        $GLOBALS['smarty']->assign('categories', $categories);
		
		return $GLOBALS['smarty']->fetch('mailing_nouveau.tpl');
	}
	
	public function edit()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
			exit;
		
		$cats = getClientCategorie();
        $categories = array('0' => $GLOBALS['lang']['Toutes']);
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['titre'];
        }
        
        // Recuperation des catgories
        $GLOBALS['smarty']->assign('categories', $categories);
		$GLOBALS['smarty']->assign('mailing', $this->mailing);
		return $GLOBALS['smarty']->fetch('mailing_modif.tpl');
	}
	
	/**
	*	@desc Supprime le mailing de la base
	* 	@return redirection vers la page d index
	* */
	public function delete()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['del'] != 1)
			exit;
	
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification des donnes reu
		if( $this->mailing == '')
			return false;
			
		// Suppression de la base
		if($this->model->delete($this->data['mailing_id']))
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_supprime']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_suppression'] . '|warning');
	}
	
	/**
	*	@desc Sauvegarde le mailing et construit la liste des emails pour envoie
	* */
	public function save()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( !isset($this->data['send']) &&  !isset($this->data['edit']))
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_enregistrement'].'|warning');
			
		$data = $this->data['mailing'];
		
		// Verification du texte
		if($data['texte_html'] == '' && $data['texte'] == '')
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_enregistrement'].'|warning');
		
		// verification du titre
		if($data['titre'] == '')
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_enregistrement'].'|warning');
			
		if( isset($this->data['send']) )
		{
			if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
				exit;
				
			// Sauvegarde dans la base
			if( $this->model->add($data) )
				return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing&a=vue&mailing_id='. $GLOBALS['db']->LastInsertId(),3,$GLOBALS['lang']['Mailing_enregistre']);
			else
				return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_enregistrement'].'|warning');
		}
		
		if( isset($this->data['edit']) )
		{
			if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
				exit;
				
			// Sauvegarde dans la base
			if( $this->model->edit($data) )
				return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing&a=vue&mailing_id='. $data['id'],3,$GLOBALS['lang']['Mailing_enregistre']);
			else
				return redirect($GLOBALS['setting']['url_site'].'index.php?c=mailing',3,$GLOBALS['lang']['Mailing_erreur_enregistrement'].'|warning');
		}
			
	}
	
	public function vue()
	{
		if( $this->mailing == '')
			return false;
		
		$GLOBALS['smarty']->assign('mailing', $this->mailing);
		return $GLOBALS['smarty']->fetch('mailing_vue.tpl');
	}
	
	public function ajaxConstructListe()
	{
		@set_time_limit(0);
		
		if( $this->mailing == '')
			return false;
			
		$this->model->ConstructEmailListe($this->mailing['categorie_id'] != 0 ? " AND categorie_id = ". $this->mailing['categorie_id'] ." " : '', $this->data['mailing_id']);
		return $this->ajaxVueReloadDivAction();
	}
	
	public function ajaxSendMailing()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['envoyer'] != 1)
			exit;
			
		@set_time_limit(0);
		
		if( $this->mailing == '')
			return false;
			
		// Recuperation des emails
		$r = $this->model->getEmailForSend($this->data['mailing_id']);
		
		foreach($r as $mail)
		{
			$emails[] = $mail['client_email'];
		}
		
		// Supression des doublons
		$emails = array_unique($emails);
		
		// Construction array avec les donnes du mailing
		$data = array(
		'expediteur_email'	=>	$GLOBALS['setting']['mailing_email'],
		'expediteur'	=>	$GLOBALS['setting']['nom_societe'],
		'destinataire'	=>	$emails,
		'sujet'	=>	$this->mailing['titre'],
		'message'	=>	$this->mailing['texte'] != '' ? $this->mailing['texte'] . "\r\n\r\n\r\n". $GLOBALS['setting']['mailing_signature'] : '',
		'message_html'	=>	$this->mailing['texte_html'] != '' ? $this->mailing['texte_html'] . "<br/><br/><br/>". $GLOBALS['setting']['mailing_signature_html'] : '',
		);
		
		// Inclusion fichier pour envoie email
		require_once IF_ROOT_PATH . 'core'. DS .'functions_email.php';
		
		// Envoie du mailing
		if( sendEmail($data) )
		{
			// On enregistre dans la base l envoie du mailing
			$this->model->setMailingSended($this->data['mailing_id']);
			return $this->ajaxVueReloadDivAction();
		}
		else
		{
			// Notification de l erreur
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=mailing&a=vue&mailing_id='. $this->data['mailing_id'],5,$GLOBALS['lang']['Erreur_envoie_mailing'].'|warning');
		}
	}
	
	public function ajaxVueReloadDivAction()
	{
		$GLOBALS['smarty']->assign('mailing', $this->model->getById($this->data['mailing_id']));
		return $GLOBALS['smarty']->fetch('Ajax_mailing_vue_relaod_action.tpl');
	}
}