<?php

class mailingAdmin extends controller
{
	protected $model;
	
	public function __construct()
	{
		require_once IF_ROOT_PATH . 'model'. DS .'mailingAdmin.php';
		
		if($_SESSION['utilisateur']['admin'] != 1)
			redirect($GLOBALS['setting']['url_site'] . 'index.php?access_violation');        
        
        $this->getData();
		
		$this->model = new mailingAdminModel();
	}
	
	public function index()
	{
		return $GLOBALS['smarty']->fetch('mailingAdmin_index.tpl');
	}
	
	public function index_auth()
	{
		getUserSelect();
		return $GLOBALS['smarty']->fetch('mailingAdmin_index_auth.tpl');
	}
	
	public function authUpdate()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( !isset($this->data['sendAuth']) ):
			redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_auth',0);
			exit;
		endif;
		
		// Collecte des donnes
		$data = array();
		
		if( !isset($this->data['ajout']) )
			$data['ajout'] = 0;
		else
			$data['ajout'] = 1;
			
		if( !isset($this->data['del']) )
			$data['del'] = 0;
		else
			$data['del'] = 1;
			
		if( !isset($this->data['envoyer']) )
			$data['envoyer'] = 0;
		else
			$data['envoyer'] = 1;	

		if( !isset($this->data['modif']) )
			$data['modif'] = 0;
		else
			$data['modif'] = 1;			
			
		$data['id'] = $this->data['id'];
		$data['user_id'] = $this->data['user_id'];
		
		// Envoie des donnes dans la base
		if( $this->model->updateAuth($data) )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=mailingAdmin&a=index_auth', 3, $GLOBALS['lang']['Droit_mise_a_jour']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=mailingAdmin&a=index_auth', 3, $GLOBALS['lang']['Erreur_mise_a_jour_droit'].'|warning');
	}
	/**
	*	@desc Affiche le formulaire des modifications des preferences
	*	@return mixed code HTML de la page
	* */
	public function preference()
	{
		return $GLOBALS['smarty']->fetch('mailingAdmin_preference.tpl');
	}
	
	public function ajaxShowAuth()
	{
		// Recuperation des droits
		$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		
		// verification que les droits on bien ete recuperer. Sinon on force une mise  jour de ceci et nous les recuperons de nouveau
		if(!$authForUser):
			$this->model->UpdateAuthByUser($this->data['utilisateur_id']);
			$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		endif;
		
		// Envoie des auth au template
		$GLOBALS['smarty']->assign('auth', $authForUser);
		
		// Affichage du template
        return $GLOBALS['smarty']->fetch('Ajax_mailingAdmin_ShowAuth.tpl');
	}
}