<?php
class mdj extends controller
{	
	protected $model;
	protected $mdj;
	private $auth;
	
	public function __construct()
	{
		require_once IF_ROOT_PATH . 'model'. DS .'mdj.php';
		$this->model = new mdjModel();
		
		$this->getData();
		
		if( isset($this->data['mdj_id']) )
			$this->mdj = $this->model->getById($this->data['mdj_id']);
			
		// Recuperation des droits
		$this->auth = $this->getAuth('auth_mdj');
		// Envoie des droits au template
		$GLOBALS['smarty']->assign('auth', $this->auth);
		
	}
	public function index()
	{
		$GLOBALS['smarty']->assign('mdjs',$this->model->getAll(50));
		return $GLOBALS['smarty']->fetch('mdj_index.tpl');
	}
	
	public function view()
	{
		$GLOBALS['smarty']->assign('mdj',$this->mdj);
		return $GLOBALS['smarty']->fetch('mdj_view.tpl');
	}
	
	public function ajout()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
			exit;
			
		return $GLOBALS['smarty']->fetch('mdj_ajout.tpl');
	}
	
	public function edit()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
			exit;
			
		$GLOBALS['smarty']->assign('mdj', $this->mdj);
		return $GLOBALS['smarty']->fetch('mdj_modif.tpl');
	}
	
	public function send()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		$data = $this->data['mdj'];
			
		if( $data['titre'] == '' || $data['texte'] == '')
			redirect(URL_SITE . 'index.php?c=mdj',0);
		
		if( isset($this->data['ajout']) )
		{
			// Verification des droits
			if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
				exit;
			
			if($this->model->add($data))
				return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Mot_du_jour_enregistre']);
			else
				return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Erreur_enregistrement'] . '|warning');
		}
		
		if( isset($this->data['edit']) )
		{
			// Verification des droits
			if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
				exit;
				
			if($this->model->edit($data))
				return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Mot_du_jour_enregistre']);
			else
				return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Erreur_enregistrement'] . '|warning');
		}
	}
	
	public function delete()
	{
		if( $_SESSION['utilisateur']['admin'] != 1 && $this->auth['del'] != 1)
			exit;
	
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification des donnes reu
		if( $this->mdj == '')
			return false;
			
		// Suppression de la base
		if($this->model->delete($this->data['mdj_id']))
			return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Mot_du_jour_supprime']);
		else
			return redirect(URL_SITE . 'index.php?c=mdj',3,$GLOBALS['lang']['Erreur_suppression'] . '|warning');
	}
}