<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
class produitAdmin extends controller
{
    private $model;
    private $controller = 'produitAdmin';
    
    public function  __construct()
    {
        if($_SESSION['utilisateur']['admin'] != 1) redirect (URL_SITE);         // Verification des droits

        require_once IF_ROOT_PATH . 'model' . DS . 'produitAdmin.php';

        $this->model = new produitAdminModel();

        parent::__construct();                                                  // Appel de la methode parent
    }

    public function index()
    {
        return $this->smarty->fetch('produitAdmin_index.tpl');
    }

    public function index_categorie()
    {
        $this->smarty->assign(array(
            'controller' => $this->controller,
            'categories'    =>  $this->model->getCategories(true),
        ));
        return $this->smarty->fetch('produitAdmin_index_categorie.tpl');
    }

    public function index_auth()
    {
        getUserSelect();
        return $GLOBALS['smarty']->fetch('produitAdmin_index_auth.tpl');
    }

    public function ajaxShowAuth()
    {
        $table = 'produit';

        // Recuperation des droits
        $authForUser = $this->model->getAuthByUser($this->data['utilisateur_id'], $table);

        // verification que les droits on bien ete recuperer. Sinon on force une mise  jour de ceci et nous les recuperons de nouveau
        if(!$authForUser):
                $this->model->UpdateAuthByUser($this->data['utilisateur_id'], $table);
                $authForUser = $this->model->getAuthByUser($this->data['utilisateur_id'],$table);
        endif;

        // Envoie des auth au template
        $GLOBALS['smarty']->assign('auth', $authForUser);

        // Affichage du template
        return $GLOBALS['smarty']->fetch('produitAdmin_ajaxShowAuth.tpl');
    }

    public function authUpdate()
    {
        $table = 'produit';

        $GLOBALS['session']->checkCsrfPost();

            if( !isset($this->data['sendAuth']) )
                    redirect($GLOBALS['setting']['url_site'] . 'index.php?c='. $this->controller .'&a=index_auth',0);

            // Collecte des donnes
            $data = array();

            if( !isset($this->data['ajout']) ) $data['ajout'] = 0; else $data['ajout'] = 1;

            if( !isset($this->data['del']) ) $data['del'] = 0; else $data['del'] = 1;

            if( !isset($this->data['modif']) ) $data['modif'] = 0; else $data['modif'] = 1;

            if( !isset($this->data['voir_prix_vente']) ) $data['voir_prix_vente'] = 0; else $data['voir_prix_vente'] = 1;

            if( !isset($this->data['voir_prix_achat']) ) $data['voir_prix_achat'] = 0; else $data['voir_prix_achat'] = 1;

            if( !isset($this->data['ajout_sortie']) ) $data['ajout_sortie'] = 0; else $data['ajout_sortie'] = 1;

            if( !isset($this->data['ajout_entree']) ) $data['ajout_entree'] = 0; else $data['ajout_entree'] = 1;

            $data['id'] = $this->data['id'];
            $data['user_id'] = $this->data['user_id'];

            // Envoie des donnes dans la base
            if( $this->model->updateAuth($data, $table) )
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c='. $this->controller .'&a=index_auth', 3, $GLOBALS['lang']['Droit_mise_a_jour']);
            else
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c='. $this->controller .'&a=index_auth', 3, $GLOBALS['lang']['Erreur_mise_a_jour_droit'].'|warning');
    }

    public function categorie_ajout()
    {
        $this->smarty->assign(array(
            'controller' => $this->controller,
            'categories' => $this->model->getCategories()
        ));
        return $this->smarty->fetch('produitAdmin_categorie_ajout.tpl');
    }

    public function categorie_edit()
    {
        $this->smarty->assign(array(
            'categorie' =>  $this->model->getCategorie($this->data['categorie_id']),
            'controller' => $this->controller,
            'categories' => $this->model->getCategories(),
        ));
        return $this->smarty->fetch('produitAdmin_categorie_edit.tpl');
    }

    public function categorie_send()
    {
        $GLOBALS['session']->checkCsrfPost();

        $categorie = $this->data['categorie'];

        if($categorie['nom'] == '') redirect(URL_SITE . 'index.php?c=fournisseurAdmin');

        if( isset($this->data['categorie_add']) )
        {
            $this->model->add($categorie, PREFIX . 'produit_categorie');
            return redirect(URL_SITE . 'index.php?c=produitAdmin&a=index_categorie', 3, $GLOBALS['lang']['Categorie_ajoutee']);
        }

        if( isset($this->data['categorie_edit']) )
        {
            $this->model->update($categorie, PREFIX . 'produit_categorie');
            return redirect(URL_SITE . 'index.php?c=produitAdmin&a=index_categorie', 3, $GLOBALS['lang']['Categorie_modifiee']);
        }

    }

    public function categorie_delete()
    {
        $GLOBALS['session']->checkCsrfGet();

        $this->model->delete($this->data['categorie_id'],PREFIX .'produit_categorie');

        return redirect(URL_SITE . 'index.php?c=produitAdmin&a=index_categorie', 3, $GLOBALS['lang']['Categorie_supprimee']);
    }

}
?>
