<?php
class prospect extends controller
{
    protected $model;
    protected $prospect;
	protected $prospect_affiche = 50;
    protected $auth;
    
    public function __construct()
    {
        require_once IF_ROOT_PATH . 'model' . DS . 'prospect.php';
		
		$this->model = new prospectModel();
        
        $this->getData();
	
		if( isset($this->data['prospect_id']) )
			$this->prospect = $this->model->getById($this->data['prospect_id']);
            
        $this->auth = $this->getAuth('auth_prospect');
        
        $GLOBALS['smarty']->assign('auth', $this->auth);
    }
    
    /**
     * @desc Affiche la liste des propects.
     * */
    public function index()
    {		
		/**
        * TRAITEMENT PAGINATION
        * */
       // On demande la quantit client en base 
       $nb_prospect = $this->getNumberRow(PREFIX . 'prospect', ''); 
       
       // Nombre de page 
       $nb_page = ceil($nb_prospect/$this->prospect_affiche);
       
       /* Rcupration du numro de la page courante depuis l'URL avec la mthode GET */
	   if(!isset($this->data['p']) || !is_numeric($this->data['p']) ) // si $_GET['p'] n'existe pas OU $_GET['p'] n'est pas un nombre (petite scurit supplmentaire)
		  $current_page = 1; // la page courante devient 1
	   else
	   {
    		$page = intval($this->data['p']);                 // stockage de la valeur entire uniquement
    		if ($page < 1) $current=1;                        // cas o le numro de page est infrieure 1 : on affecte 1  la page courante
    		elseif ($page > $nb_page) $current_page=$nb_page;   //cas o le numro de page est suprieur au nombre total de pages : on affecte le numro de la dernire page  la page courante
    		else $current_page=$page;                         // sinon la page courante est bien celle indique dans l'URL
	   }
       
       // Calcul du OFFSET pour la requete
       $offset = ($current_page * $this->prospect_affiche - $this->prospect_affiche);

       // Inclusion fichier pour l affichage
       require_once IF_ROOT_PATH . 'lib'. DS .'pagination.php';

       /**
        * --- FIN PAGINATION ---
        * */
		
		$GLOBALS['smarty']->assign('pagination', paginate($GLOBALS['setting']['url_site'] . 'index.php?c=prospect', '&p=', $nb_page, $current_page) );  
		$GLOBALS['smarty']->assign('prospects', $this->model->getAll($this->prospect_affiche, $offset) );
	
        return $GLOBALS['smarty']->fetch('prospect_index.tpl');
    }
    
    public function ajout()
    {
        if($_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
            redirect(URL_SITE . 'index.php?c=prospect&error=access_violation');
            
		$cats = getClientCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat):
            $categories[''. $cat['id'] .''] = $cat['titre'];
        endforeach;
        
        // Recuperation des catgories
        $GLOBALS['smarty']->assign('categories', $categories);
		
		$GLOBALS['smarty']->assign('methode',$this->model->getMethodeContact() );
        return $GLOBALS['smarty']->fetch('prospect_ajout.tpl');
    }
	
	public function send()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
		$prospect = $this->data['prospect'];
		
		// Verification des donnes envoyes
		if($prospect['nom'] == '' && $prospect['societe'] == '')
			return false;
			
		// Enregistrement du propspect dans la base
		
		if( isset($this->data['ajout']) )
		{
            if($_SESSION['utilisateur']['admin'] != 1 && $this->auth['ajout'] != 1)
                redirect(URL_SITE . 'index.php?c=prospect&error=access_violation');
            
			$prospect['user_add'] = $_SESSION['utilisateur_id'];
			
			if( $this->model->add($prospect, PREFIX . 'prospect') )
				$prospect_id = $GLOBALS['db']->LastInsertId();
				
			if( $this->data['contact']['description'] != '' )
			{
				$prospection = $this->data['contact'];
				$prospection['prospect_id'] = $prospect_id;
				$prospection['user_id'] = $_SESSION['utilisateur_id'];
				
				$this->model->add($prospection, PREFIX . 'prospection');
			}
			
			if($prospect_id)
				return redirect(URL_SITE . 'index.php?c=prospect',3,$GLOBALS['lang']['Prospect_ajoute']);
			else
				return redirect(URL_SITE . 'index.php?c=prospect',3,$GLOBALS['lang']['Erreur_enregistrement'].'|warning');				
		}		
        
        if( isset($this->data['edition']) )
        {
            if($_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
                redirect(URL_SITE . 'index.php?c=prospect&error=access_violation');
            
            // Modification du prospect
            if( $this->model->update($prospect, PREFIX . 'prospect') )
                return redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $prospect['id'], 3, $GLOBALS['lang']['Prospect_modifie']);
            else
                return redirect(URL_SITE . 'index.php?c=prospect',3,$GLOBALS['lang']['Erreur_enregistrement'].'|warning');
        }
	}
	
	public function fiche()
	{
		if($this->prospect == '')
			redirect(URL_SITE . 'index.php?c=prospect');
			
		$GLOBALS['smarty']->assign('prospect', $this->prospect);
		$GLOBALS['smarty']->assign('prospections', $this->model->getProspectionByProspect($this->data['prospect_id']) );
		$GLOBALS['smarty']->assign('methode',$this->model->getMethodeContact() );
		$GLOBALS['smarty']->assign('suivis', $this->model->getSuiviByProspect($this->data['prospect_id']) );
		return $GLOBALS['smarty']->fetch('prospect_fiche.tpl');
	}
    
    public function edit()
    {
        if($_SESSION['utilisateur']['admin'] != 1 && $this->auth['modif'] != 1)
            redirect(URL_SITE . 'index.php?c=prospect&error=access_violation');
                
        if($this->prospect == '')
            redirect(URL_SITE . 'index.php?c=prospect');
            
        $cats = getClientCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['titre'];
        }
        
        // Recuperation des catgories
        $GLOBALS['smarty']->assign('categories', $categories);
        
        $GLOBALS['smarty']->assign('prospect', $this->prospect);
        return $GLOBALS['smarty']->fetch('prospect_edit.tpl');
    }
    
    public function delete()
    {
        $GLOBALS['session']->checkCSRFget();
        
        if($this->prospect == '')
            redirect(URL_SITE. 'index.php?c=prospect');
            
        if($_SESSION['utilisateur']['admin'] != 1 && $this->auth['del'] != 1)
            redirect(URL_SITE. 'index.php?c=prospect&error=access_violation');
            
        // Supression de la base
        $this->model->delete( $this->data['prospect_id'], PREFIX . 'prospect' );
        $this->model->deleteLink($this->data['prospect_id']);
        return redirect(URL_SITE. 'index.php?c=prospect',3,$GLOBALS['lang']['Prospect_supprime']);
    }
    
	
	public function contact_send()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
		if($this->model->add($this->data['contact'], PREFIX . 'prospection'))
			return redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['contact']['prospect_id'],3,$GLOBALS['lang']['Contact_ajoute']);
		else
			return redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['contact']['prospect_id'],3,$GLOBALS['lang']['Erreur_enregistrement'].'|warning');
	}	
	
	public function suivi_send()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
		if($this->model->add($this->data['suivi'], PREFIX . 'prospect_suivi'))
			return redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['suivi']['prospect_id'],3,$GLOBALS['lang']['Suivi_ajoute']);
		else
			return redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['suivi']['prospect_id'],3,$GLOBALS['lang']['Erreur_enregistrement'].'|warning');
	}
    
    public function suivi_delete()
    {
        // Verification du jeton
        $GLOBALS['session']->checkCSRFget();
        
        // Verification admin
        if( $_SESSION['utilisateur']['admin'] != 1)
            redirect(URL_SITE . 'index.php?c=prospect&error=access_violation',0);
            
        // Suppression de la base
        $this->model->delete($this->data['suivi_id'], PREFIX . 'prospect_suivi');
        
        // Redirection de l utilisateur
        redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['prospect_id']);
    }
    
    public function prospection_delete()
    {
        // Verification du jeton
        $GLOBALS['session']->checkCSRFget();
        
        // Verification admin
        if( $_SESSION['utilisateur']['admin'] != 1)
            redirect(URL_SITE . 'index.php?c=prospect&error=access_violation',0);
            
        // Suppression de la base
        $this->model->delete($this->data['prospection_id'], PREFIX . 'prospection');
        
        // Redirection de l utilisateur
        redirect(URL_SITE . 'index.php?c=prospect&a=fiche&prospect_id='. $this->data['prospect_id']);
            
             
    }
	
	public function ajaxCheckTelephone()
	{
		$GLOBALS['smarty']->assign('pros', $this->model->checkTelephone($this->data['telephone']) );
		$GLOBALS['smarty']->assign('clt', $this->model->checkTelephoneClient($this->data['telephone']) );
		return $GLOBALS['smarty']->fetch('Ajax_prospect_check_telephone.tpl');
	}
	
	public function ajaxCheckNom()
	{
		$GLOBALS['smarty']->assign('pros', $this->model->checkNom($this->data['nom'], PREFIX .'prospect') );
		$GLOBALS['smarty']->assign('clt', $this->model->checkNom($this->data['nom'], PREFIX .'client') );
		return $GLOBALS['smarty']->fetch('Ajax_prospect_check_nom.tpl');
	}
	
	public function ajaxCheckSociete()
	{
		$GLOBALS['smarty']->assign('pros', $this->model->checkSociete($this->data['societe'], PREFIX .'prospect') );
		$GLOBALS['smarty']->assign('clt', $this->model->checkSociete($this->data['societe'], PREFIX .'client') );
		return $GLOBALS['smarty']->fetch('Ajax_prospect_check_nom.tpl');
	}
	
	public function ajaxAutoSearch()
	{
		$resultat = '';
		if( isset($this->data['queryString']) )
		{
			$queryString  =  $this->data['queryString'];
			
			if( strlen($queryString) > 0)
			{
				// Construction de la requete
				if( is_numeric($queryString) )
				{
					// Numero de telephone recherche
					$query = "SELECT id, nom, prenom, societe, telephone, fax, portable FROM ". PREFIX ."prospect WHERE (telephone LIKE '%$queryString%' OR portable LIKE '%$queryString%' OR fax LIKE '%$queryString%') LIMIT 10";
				}
				else
					$query = "SELECT id, nom, prenom, societe, telephone, fax, portable FROM ". PREFIX ."prospect WHERE (nom LIKE '%$queryString%' OR societe LIKE '%$queryString%') LIMIT 10";

				// Execution requete
				$req = $GLOBALS['db']->query($query);
				$res = $req->fetchAll();
				
				if( count($res) > 0 )
				{
					$GLOBALS['smarty']->assign('prospects',$res);
					return $GLOBALS['smarty']->fetch('Ajax_prospect_autosearch.tpl');
				}
				else
					return $resultat;
			}
			else
				return $resultat;
		}
		else
			return $resultat;		
	}
}
?>