<?php
class prospectAdmin extends controller
{
	 protected $model;
	 private $controller = 'prospect';
	 
	public function __construct()
    {
		if($_SESSION['utilisateur']['admin'] != 1)
			redirect($GLOBALS['setting']['url_site'] . 'index.php?access_violation');  
			
        require_once IF_ROOT_PATH . 'model' . DS . 'prospectAdmin.php';
		
		$this->model = new prospectAdminModel();
        
        $this->getData();
    }
	
	public function index()
	{
		return $GLOBALS['smarty']->fetch('prospectAdmin_index.tpl');
	}
	
	public function index_auth()
	{
		getUserSelect();
		return $GLOBALS['smarty']->fetch('prospectAdmin_index_auth.tpl');
	}
	
	public function ajaxShowAuth()
	{
		// Recuperation des droits
		$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id'], 'prospect');
		
		// verification que les droits on bien ete recuperer. Sinon on force une mise  jour de ceci et nous les recuperons de nouveau
		if(!$authForUser):
			$this->model->UpdateAuthByUser($this->data['utilisateur_id'], 'prospect');
			$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id'],'prospect');
		endif;
		
		// Envoie des auth au template
		$GLOBALS['smarty']->assign('auth', $authForUser);
		
		// Affichage du template
        return $GLOBALS['smarty']->fetch('Ajax_prospectAdmin_ShowAuth.tpl');
	}
	
	public function authUpdate()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( !isset($this->data['sendAuth']) )
			redirect($GLOBALS['setting']['url_site'] . 'index.php?c=prospectAdmin&a=index_auth',0);
		
		// Collecte des donnes
		$data = array();
		
		if( !isset($this->data['ajout']) )
			$data['ajout'] = 0;
		else
			$data['ajout'] = 1;
			
		if( !isset($this->data['del']) )
			$data['del'] = 0;
		else
			$data['del'] = 1;

		if( !isset($this->data['modif']) )
			$data['modif'] = 0;
		else
			$data['modif'] = 1;			
			
		$data['id'] = $this->data['id'];
		$data['user_id'] = $this->data['user_id'];
		
		// Envoie des donnes dans la base
		if( $this->model->updateAuth($data, 'prospect') )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=prospectAdmin&a=index_auth', 3, $GLOBALS['lang']['Droit_mise_a_jour']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=prospectAdmin&a=index_auth', 3, $GLOBALS['lang']['Erreur_mise_a_jour_droit'].'|warning');
	}
	
	public function index_methode_prospection()
	{
		$GLOBALS['smarty']->assign('methodes', $this->model->getAll(PREFIX . 'prospect_methode_contact'));
		return $GLOBALS['smarty']->fetch('prospectAdmin_methode_prospection_index.tpl');
	}
	
	public function methode_ajout()
	{
		return $GLOBALS['smarty']->fetch('prospectAdmin_methode_ajout.tpl');
	}
	
	public function methode_edit()
	{
		$methode = $this->model->getById($this->data['methode_id'], PREFIX . 'prospect_methode_contact');
		
		if( $methode == '')
			redirect(URL_SITE.'index.php?c=prospectAdmin',0);
		
		$GLOBALS['smarty']->assign('methode', $methode );
		return $GLOBALS['smarty']->fetch('prospectAdmin_methode_edit.tpl');
	}
	
	public function methode_send()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfPost();
		
		if( isset($this->data['methode_add']) )
		{
			$this->model->add($this->data['methode'], PREFIX . 'prospect_methode_contact');
			
			// Redirection
			return redirect(URL_SITE . 'index.php?c=prospectAdmin&a=index_methode_prospection',3,$GLOBALS['lang']['Methode_ajoutee']);
		}
			
		if( isset($this->data['methode_update']) )
		{
			// Verification que le methode existe
			if($this->model->getById($this->data['methode_id'], PREFIX . 'prospect_methode_contact') == '')
				redirect(URL_SITE.'index.php?c=prospectAdmin',0);			
				
			// Mise a jour de la methode de prospect
			$this->model->update($this->data['methode'], PREFIX . 'prospect_methode_contact');
			
			// Redirection
			return redirect(URL_SITE . 'index.php?c=prospectAdmin&a=index_methode_prospection',3,$GLOBALS['lang']['Methode_modifiee']);
		}
	}
	
	public function methode_delete()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		if($this->model->getById($this->data['methode_id'], PREFIX . 'prospect_methode_contact') == '')
			redirect(URL_SITE.'index.php?c=prospectAdmin',0);
		
		$this->model->delete($this->data['methode_id'], PREFIX . 'prospect_methode_contact');
		
		// Redirection
			return redirect(URL_SITE . 'index.php?c=prospectAdmin&a=index_methode_prospection',3,$GLOBALS['lang']['Methode_supprimee']);
	}
}
