<?php

require_once IF_ROOT_PATH . 'model'. DS . 'ticket.php';

class ticket extends controller
{
	protected $model;
	protected $ticket;
	private $ticket_affiche = 30;
	private $auth;
	
	public function __construct()
	{
		$this->getData();
		$this->model = new modelTicket();
		
		if( isset($this->data['ticket_id']) )
			$this->ticket = $this->model->getTicketById($this->data['ticket_id']);
		
		// Recuperation des droits
		$this->auth = $this->getAuth('auth_ticket');
		// Envoie des droits au template
		$GLOBALS['smarty']->assign('auth', $this->auth);
	}
	
	public function index()
	{
		/**
        * TRAITEMENT PAGINATION
        * */
       // On demande la quantit client en base 
       $nb_ticket = $this->getNumberRow(PREFIX . 'ticket', ''); 
       
       // Nombre de page 
       $nb_page = ceil($nb_ticket/$this->ticket_affiche);
       
       /* Rcupration du numro de la page courante depuis l'URL avec la mthode GET */
	   if(!isset($this->data['p']) || !is_numeric($this->data['p']) ) // si $_GET['p'] n'existe pas OU $_GET['p'] n'est pas un nombre (petite scurit supplmentaire)
		  $current_page = 1; // la page courante devient 1
	   else
	   {
    		$page = intval($this->data['p']);                 // stockage de la valeur entire uniquement
    		if ($page < 1) $current=1;                        // cas o le numro de page est infrieure 1 : on affecte 1  la page courante
    		elseif ($page > $nb_page) $current_page=$nb_page;   //cas o le numro de page est suprieur au nombre total de pages : on affecte le numro de la dernire page  la page courante
    		else $current_page=$page;                         // sinon la page courante est bien celle indique dans l'URL
	   }
       
       // Calcul du OFFSET pour la requete
       $offset = ($current_page * $this->ticket_affiche - $this->ticket_affiche);

       // Inclusion fichier pour l affichage
       require_once IF_ROOT_PATH . 'lib'. DS .'pagination.php';
        
       /**
        * --- FIN PAGINATION ---
        * */
       $GLOBALS['smarty']->assign('pagination', paginate($GLOBALS['setting']['url_site'] . 'index.php?c=ticket', '&p=', $nb_page, $current_page) );
		
		$GLOBALS['smarty']->assign('tickets', $this->model->getAllTicket('', $this->ticket_affiche, $offset) );
		return $GLOBALS['smarty']->fetch('ticket_index.tpl');
	}
	
	public function detail()
	{
		if( $this->ticket == '' )
			redirect($GLOBALS['setting'] . 'index.php?c=ticket');
		
		$GLOBALS['smarty']->assign('ticket', $this->ticket);																			// Envoie des donnnes du tickets	
		$GLOBALS['smarty']->assign('interventions', $this->model->getInterventionByTicket($this->data['ticket_id']) );
		if($GLOBALS['setting']['ticket_intervention_demande'] == 1)
			$GLOBALS['smarty']->assign('intervention_demandes', $this->model->getInterventionDemandeByTicket($this->data['ticket_id']) );
		if($GLOBALS['setting']['ticket_intervention_demande'] == 1)
			$GLOBALS['smarty']->assign('historique', $this->model->getHistoriqyeByTicketId($this->data['ticket_id']));
		$GLOBALS['smarty']->assign('fichiers', getFileInDir(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $this->data['ticket_id']) );	// Envoie de la liste des fichiers
		$GLOBALS['smarty']->assign('suivis', $this->model->getSuiviByTicket($this->data['ticket_id']) );								// Envoie du suivie
		$GLOBALS['smarty']->assign('types_intervention', $this->model->getTypeIntervention() );											// Envoie des types d'intervention
		return $GLOBALS['smarty']->fetch('ticket_detail.tpl');
	}
	
	public function ajout()
	{
		if($this->auth['ajout'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
			return false;
			
		$cats = $this->model->getTicketCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['nom'];
        }
		
		if( isset($this->data['client_id']) )
		{
			$client = $this->model->getNameClient($this->data['client_id']);
			
			if($client != '')
				$GLOBALS['smarty']->assign('client', $client);
		}
		else
			getClientSelect();		
			
		$GLOBALS['smarty']->assign('categories', $categories);
		
		return $GLOBALS['smarty']->fetch('ticket_ajout.tpl');
	}
	
	public function edit()
	{
		if($this->auth['modif'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
			return false;
			
		$cats = $this->model->getTicketCategorie();
        $categories = array('' => '--------');
        
        foreach($cats as $cat)
        {
            $categories[''. $cat['id'] .''] = $cat['nom'];
        }
		
		if( isset($this->data['client_id']) )
		{
			$client = $this->model->getNameClient($this->data['client_id']);
			
			if($client != '')
				$GLOBALS['smarty']->assign('client', $client);
		}
		else
			getClientSelect();		
		
		$GLOBALS['smarty']->assign('ticket', $this->ticket);
		
		$GLOBALS['smarty']->assign('categories', $categories);
		
		return $GLOBALS['smarty']->fetch('ticket_edit.tpl');
	}
	
	public function delete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->ticket == '' )
			return false;
	
		if($this->auth['ajout'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
			return false;
			
		$this->model->delete($this->data['ticket_id']);
		
		return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket',3,$GLOBALS['lang']['Ticket_supprime']);
	}
	
	public function save()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		$data = $this->data['ticket'];
		
		if( isset($this->data['ticket_ajout']) )
		{
			if($this->auth['ajout'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
			return false;
		
			if($data['titre'] == '' || $data['client_id'] == '' || $data['description'] == '')
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket&a=ajout',3,$GLOBALS['lang']['Formulaire_incomplet'] . '|warning');
				
			if( $this->model->add($data) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket',3,$GLOBALS['lang']['Ticket_ajoute']);
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket&a=ajout',3,$GLOBALS['lang']['Ticket_erreur_ajout'] . '|warning');
		}	
		
		if( isset($this->data['ticket_edit']) )
		{
			if($this->auth['modif'] != 1 && $_SESSION['utilisateur']['admin'] != 1)
			return false;
		
			if($data['titre'] == '' || $data['description'] == '')
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket',3,$GLOBALS['lang']['Formulaire_incomplet'] . '|warning');
				
			if( $this->model->edit($data) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket&a=detail&ticket_id='. $data['id'],3,$GLOBALS['lang']['Ticket_modifie']);
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticket',3,$GLOBALS['lang']['Ticket_erreur_modif'] . '|warning');
		}
	}
	
	public function ajaxSuiviShowForm()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->ticket == '')
			return false;
			
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_form_suivi_ajout.tpl');
	}
	
	public function ajaxUserAttrib()
	{
		getUserSelect();
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_form_attrib.tpl');
	}
	
	/**
	*	@desc Enregistrement l attribution du ticket au membre
	* */
	public function ajaxSendAttrib()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->ticket == '')
			return false;
			
		if( $this->data['user_attrib'] == '' || !is_numeric($this->data['user_attrib']) )
			return false;
			
		$this->model->saveAttrib($this->data['ticket_id'], $this->data['user_attrib']);
			
		return $this->ajaxReloadDetail();
	}
	
	public function ajaxReloadDetail()
	{
		$GLOBALS['smarty']->assign('ticket',$this->model->getTicketById($this->data['ticket_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_reload.tpl');
	}
	
	public function ajaxSuiviReload()
	{
		$GLOBALS['smarty']->assign('suivis', $this->model->getSuiviByTicket($this->data['ticket_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_suivi_reload.tpl');
	}
	
	public function ajaxSuiviSend()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( $this->ticket == '')
			return false;
			
		if( $this->data['suivi'] == '')
			return false;
		
		$this->model->SuiviSave(array('ticket_id' => $this->data['ticket_id'], 'user_id'	=>	$_SESSION['utilisateur_id'], 'suivi'	=>	$this->data['suivi']) );
		
		return $this->ajaxSuiviReload();
	}
	
	public function ajaxSuiviDelete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if($_SESSION['utilisateur']['admin'] != 1)
			exit;
		
		if( $this->ticket == '')
			return false;
			
		$this->model->SuiviDelete(array('suivi_id'	=>	$this->data['suivi_id'], 'ticket_id' => $this->data['ticket_id']));
		
		return $this->ajaxSuiviReload();
	}
	
	/**
	*	@desc Traite l'envoie du fichier
	*	@return resultat de l'upload
	* */
	public function uploadFile()
	{
		$destination = IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $this->data['ticket_id'];
		
		$result = 0;
		
		if( !is_dir($destination) )
		{
			//Creation du dossier client
			mkdir($destination);
		}
		
		//Traitement du fichier
		
		$name = $_FILES['fichier']['name'];
		$extension = substr(strrchr($_FILES['fichier']['name'],'.'),1);
		
		//Suppression des espaces et remplacement pas un _
		$name = str_replace(' ','_',$name);
		
		//Supression des accents
		$name = strtr($name, 
          '', 
          'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
		
		// On deplace le fichier
		if(move_uploaded_file($_FILES['fichier']['tmp_name'], $destination . DS . $name)) 
		{	
			$result = 1;
		}
		sleep(1);
			
		return '<script language="javascript" type="text/javascript">window.top.window.stopUpload('. $result .');</script>';   
	}
	
	/**
	*	@desc Recharge le l'onglet du fichier dans le detail du ticket
	*	@return Le code HTML des fichiers.
	*	*/
	public function ajaxReloadFichier()
	{
		$GLOBALS['smarty']->assign('fichiers', getFileInDir(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $this->data['ticket_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_tab_fichier.tpl');
	}
	
	/**
	*	@desc Supprime le fichier selectionner
	*	@return 
	*/
	public function ajaxDeleteFichier()
	{
		if( $_SESSION['utilisateur']['admin'] != 1)
			exit;
	
		if($this->data['fichier'] == '')
			return '';
			
		if(! is_file(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $this->data['ticket_id'] . DS . $this->data['fichier']) )
			return '';
			
		unlink(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $this->data['ticket_id'] . DS . $this->data['fichier']);
		
		return '';
	}
	
	/**
	*	@desc Sauvegarde l intervention
	*	@return html code
	*/
	public function ajaxInterventionSend()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification du ticket
		if( $this->ticket == '')
			return false;
			
		// Verification des donnes qu elle ne soit pas vide
		if( $this->data['description'] == '' || $this->data['intervention_type'] == '')
			return false;
			
		// Envoie au model pour sauvegarde
		$this->model->InterventionSave( array(
			'type_id' => $this->data['intervention_type'],
			'ticket_id' => $this->data['ticket_id'],
			'user_id'	=>	$_SESSION['utilisateur_id'],
			'description'	=>	utf8_decode($this->data['description']),
			'demande_id'	=>	$this->data['demande_id'],
		));
		
		// Traitement cas demande id different de 0
		if( $this->data['demande_id'] != 0 && is_numeric($this->data['demande_id']) )
			$this->model->InterventionUpdateDemande($this->data['demande_id'], $GLOBALS['db']->lastInsertId() );
		
		// Appel fonction pour recharger la liste des interventions
		return $this->ajaxInterventionReload();
	}
	
	public function ajaxInterventionReload()
	{
		$GLOBALS['smarty']->assign('interventions', $this->model->getInterventionByTicket($this->data['ticket_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_intervention_reload.tpl');
	}
	
	public function ajaxInterventionDelete()
	{
		if( $_SESSION['utilisateur']['admin'] != 1)
			exit;
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification du ticket
		if( $this->ticket == '')
			return false;
			
		$this->model->InterventionDelete($this->data['intervention_id']);
		
		return $this->ajaxInterventionReload();
	}
	
	public function ajaxInterventionDemandeSend()
	{
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification du ticket
		if( $this->ticket == '')
			return false;
			
		if( $this->data['description'] == '')
			return false;
			
		$this->model->InterventionDemandeSave( array(
			'ticket_id'	=>	$this->data['ticket_id'],
			'user_id'	=>	$_SESSION['utilisateur_id'],
			'description'	=>	$this->data['description']
		));
		
		return $this->ajaxInterventionDemandeReload();
	}
	
	public function ajaxInterventionDemandeReload()
	{
		$GLOBALS['smarty']->assign('intervention_demandes', $this->model->getInterventionDemandeByTicket($this->data['ticket_id']) );
		return $GLOBALS['smarty']->fetch('Ajax_ticket_detail_intervention_demande_reload.tpl');
	}
	
	public function ajaxInterventionDemandeDelete()
	{
		if( $_SESSION['utilisateur']['admin'] != 1)
			exit;
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification du ticket
		if( $this->ticket == '')
			return false;
			
		$this->model->InterventionDemandeDelete($this->data['demande_id']);
		
		return $this->ajaxInterventionDemandeReload();
	}
	
	/**
	*	@desc Supprime l attribution utilsiateur
	*	@return html code
	* */
	public function ajaxAttribDelete()
	{
		// Verification admin
		if( $_SESSION['utilisateur']['admin'] != 1) exit;
			
		// Verification du jeton
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification du ticket
		if( $this->ticket == '')
			return false;
			
		$this->model->AttribDelete($this->data['ticket_id']);
		return $this->ajaxReloadDetail();
	}
    
    public function liste_demande_intervention()
    {
        $GLOBALS['smarty']->assign('intervention_demandes', $this->model->getListeDemandeIntervention());
        return $GLOBALS['smarty']->fetch('ticket_liste_demande_intervention.tpl');
    }
}