<?php

require_once IF_ROOT_PATH . 'model' . DS . 'ticketAdmin.php';

class ticketAdmin extends controller
{	
	public $model;
	
	public function __construct()
    {
        if($_SESSION['utilisateur']['admin'] != 1)
			redirect($GLOBALS['setting']['url_site'] . 'index.php?access_violation');        
        
        $this->getData();
        $this->model = new ticketAdminModel();
    }
	
	public function index()
	{
		return $GLOBALS['smarty']->fetch('ticketAdmin_index.tpl');
	}
	
	public function preference()
	{
		return $GLOBALS['smarty']->fetch('ticketAdmin_preference.tpl');
	}
	
	public function index_categorie()
	{
		$GLOBALS['smarty']->assign('categories',$this->model->getAllCategorie() );
		return $GLOBALS['smarty']->fetch('ticketAdmin_index_categorie.tpl');
	}
	
	public function categorie_ajout()
	{
		return $GLOBALS['smarty']->fetch('ticketAdmin_categorie_ajout.tpl');
	}
	
	public function categorie_edit()
	{
		$GLOBALS['smarty']->assign('categorie', $this->model->getCategorieById($this->data['categorie_id']) );
		return $GLOBALS['smarty']->fetch('ticketAdmin_categorie_edit.tpl');
	}
	
	public function categorie_send()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if($this->data['categorie']['nom'] == '')
			redirect($GLOBALS['setting']['url_site'].'index.php?c=ticketAdmin&a=index_categorie',2);
		
		if( isset($this->data['categorie_ajout']) )
		{
			if( $this->model->categorie_add($this->data['categorie']) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_categorie',3,$GLOBALS['lang']['Categorie_sauvegarde']);
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=categorie_ajout',3,$GLOBALS['lang']['Erreur_enregistrement_categorie'].'|warning');
		}
		
		if( isset($this->data['categorie_edit'])&& isset($this->data['categorie']['id']) && is_numeric($this->data['categorie']['id']))
		{
			if( $this->model->categorie_edit($this->data['categorie']) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_categorie',3,$GLOBALS['lang']['Categorie_sauvegarde']);
            else
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_categorie',3,$GLOBALS['lang']['Erreur_enregistrement_categorie'].'|warning');
            
		}
	}
	
	public function categorie_delete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( isset($this->data['categorie_id']) && is_numeric($this->data['categorie_id']) )
		{
			if($this->model->categorie_delete($this->data['categorie_id']))
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_categorie', 3, $GLOBALS['lang']['Categorie_supprimee']);
			else
				redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_categorie', 0);
		}
	}
	
	public function index_intervention_type()
	{
		$GLOBALS['smarty']->assign('intervention_type',$this->model->getAllInterventionType() );
		return $GLOBALS['smarty']->fetch('ticketAdmin_index_intervention_type.tpl');
	}
	
	public function intervention_type_ajout()
	{
		return $GLOBALS['smarty']->fetch('ticketAdmin_intervention_type_ajout.tpl');
	}
	
	public function intervention_type_edit()
	{
		$GLOBALS['smarty']->assign('type', $this->model->getInterventionTypeById($this->data['type_id']) );
		return $GLOBALS['smarty']->fetch('ticketAdmin_intervention_type_edit.tpl');
	}
	
	public function intervention_type_send()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if($this->data['type']['nom'] == '')
			redirect($GLOBALS['setting']['url_site'].'index.php?c=ticketAdmin&a=index_intervention_type',2);
		
		if( isset($this->data['type_ajout']) )
		{
			if( $this->model->intervention_type_add($this->data['type']) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_intervention_type',3,$GLOBALS['lang']['Type_sauvegarde']);
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=intervention_type_ajout',3,$GLOBALS['lang']['Erreur_enregistrement_type'].'|warning');
		}
		
		if( isset($this->data['type_edit'])&& isset($this->data['type']['id']) && is_numeric($this->data['type']['id']))
		{
			if( $this->model->intervention_type_edit($this->data['type']) )
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_intervention_type',3,$GLOBALS['lang']['Type_sauvegarde']);
            else
                return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_intervention_type',3,$GLOBALS['lang']['Erreur_enregistrement_type'].'|warning');
            
		}
	}
	
	public function intervention_type_delete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		if( isset($this->data['type_id']) && is_numeric($this->data['type_id']) )
		{
			if($this->model->intervention_type_delete($this->data['type_id']))
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_intervention_type', 3, $GLOBALS['lang']['Type_supprime']);
			else
				redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_intervention_type', 0);
		}
	}
	
	public function index_auth()
	{
		getUserSelect();
        return $GLOBALS['smarty']->fetch('ticketAdmin_index_auth.tpl');
	}
	
	/**
	*	@desc Affiche le formulaire d edition des droits
	*	@return mixed code html pour affichage
	* */
	public function ajaxShowAuth()
	{
		// Recuperation des droits
		$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		
		// verification que les droits on bien ete recuperer. Sinon on force une mise  jour de ceci et nous les recuperons de nouveau
		if(!$authForUser):
			$this->model->UpdateAuthByUser($this->data['utilisateur_id']);
			$authForUser = $this->model->getAuthByUser($this->data['utilisateur_id']);
		endif;
		
		// Envoie des auth au template
		$GLOBALS['smarty']->assign('auth', $authForUser);
		
		// Affichage du template
        return $GLOBALS['smarty']->fetch('Ajax_ticketAdmin_ShowAuth.tpl');
	}
	
	/**
	*	@desc Mise  jour des droits utilisateur
	* 	@return mixed
	* */
	public function authUpdate()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( !isset($this->data['sendAuth']) ):
			redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_auth',0);
			exit;
		endif;
		
		// Collecte des donnes
		$data = array();
		
		if( !isset($this->data['ajout']) )
			$data['ajout'] = 0;
		else
			$data['ajout'] = 1;
			
		if( !isset($this->data['modif']) )
			$data['modif'] = 0;
		else
			$data['modif'] = 1;
			
		if( !isset($this->data['del']) )
			$data['del'] = 0;
		else
			$data['del'] = 1;
			
		if( !isset($this->data['attribuer']) )
			$data['attribuer'] = 0;
		else
			$data['attribuer'] = 1;		
			
		$data['id'] = $this->data['id'];
		$data['user_id'] = $this->data['user_id'];
		
		// Envoie des donnes dans la base
		if( $this->model->updateAuth($data) )
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_auth', 3, $GLOBALS['lang']['Droit_mise_a_jour']);
		else
			return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=ticketAdmin&a=index_auth', 3, $GLOBALS['lang']['Erreur_mise_a_jour_droit'].'|warning');
	}
	
}
?>