<?php

require_once IF_ROOT_PATH . 'model'. DS .'utilisateurAdmin.php';

class utilisateurAdmin extends controller
{
	protected $model;
	protected $utilisateur;
	
	public function __construct()
	{
		if($_SESSION['utilisateur']['admin'] != 1)
        {
            redirect($GLOBALS['setting']['url_site'] . 'index.php?access_violation');
        }
        
        $this->getData();
		
		$this->model = new utilisateurModel();
		
		if( isset($this->data['utilisateur_id']) && is_numeric($this->data['utilisateur_id']) )
			$this->utilisateur = $this->model->getUtilisateurById($this->data['utilisateur_id']);	
	}
	/**
	*	@desc Page d index de la gestion utilisateur
	* */
	public function index()
	{
		$GLOBALS['smarty']->assign('utilisateurs', $this->model->getAllUser() );
		return $GLOBALS['smarty']->fetch('utilisateurAdmin_index.tpl');
	}
	
	public function edition()
	{
		if($this->utilisateur != '' && is_array($this->utilisateur) )
		{
			$GLOBALS['smarty']->assign('utilisateur', $this->utilisateur);
			return $GLOBALS['smarty']->fetch('utilisateurAdmin_edition.tpl');
		}
		else
			redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin');
	}
	
	/**
	*	@desc Verifie la disponibilit d'un identifiant dans la base de donnes
	*	@return retourne la resultat de la dispo du pseudo
	* */
	public function ajaxCheckIdentifiant()
	{
		if( $this->getNumberRow(PREFIX .'utilisateur', " WHERE identifiant = '". $this->data['identifiant'] ."'") == 0)
			return 'notUse';
		else
			return 'alreadyUse';
	}
	
	public function ajout()
	{
		return $GLOBALS['smarty']->fetch('utilisateurAdmin_ajout.tpl');
	}
	
	public function save()
	{
		$GLOBALS['session']->checkCsrfPost();
		
		if( isset($this->data['user_add']) )
		{
			// Ajout utilisateur
			if( $this->model->checkAddData($this->data['user']) )
			{
				$data = $this->data['user'];
				$data['password'] = cryptPass($data['password1']);
				unset($data['password1'], $data['password2']);				
				
				if( $this->model->user_add($data) )
					return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin', 3, $GLOBALS['lang']['Utilisateur_ajoute']);
				else
					return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin', 3, $GLOBALS['lang']['Utilisateur_erreur_ajout'].'|warning');
			}
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin&a=ajout', 3, $GLOBALS['lang']['Utilisateur_erreur_donnees_formulaire'].'|warning');
		}
		
		if( isset($this->data['user_edit']) )
		{
			// Edition utilisateur
			
			// Verification que l utilisateur existe
			if( $this->utilisateur == '')
				return redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin',3,$GLOBALS['lang']['Utilisateur_existe_pas'].'|warning');
				
			// Verification des donnes
			if( $this->model->checkUpdateData($this->data['user']) )
			{
				$data = $this->data['user'];
				
				// Gestion MDP
				if( $data['password1'] != '')
					$data['password'] = cryptPass($data['password1']);
				
				// Supression des champs
				unset($data['password1'], $data['password2']);
				
				// Enregistrement
				if( $this->model->user_update($data) )
					return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin', 3, $GLOBALS['lang']['Utilisateur_modifie']);
				else
					return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin', 3, $GLOBALS['lang']['Utilisateur_erreur_edition'].'|warning');
			}
			else
				return redirect($GLOBALS['setting']['url_site'] . 'index.php?c=utilisateurAdmin', 3, $GLOBALS['lang']['Utilisateur_erreur_donnees_formulaire'].'|warning');
		}
			
	}
	
	public function delete()
	{
		$GLOBALS['session']->checkCsrfGet();
		
		// Verification que l utilisateur existe
		if( $this->utilisateur == '')
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin',3,$GLOBALS['lang']['Utilisateur_existe_pas'].'|warning');
	
		// Verification utilisateur admin
		if( $this->utilisateur['admin'] == 1)
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin',5,$GLOBALS['lang']['Utilisateur_erreur_supression_admin'].'|warning');
		
		// Supression utilisateur
		if( $this->model->user_delete($this->data['utilisateur_id']) )
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin',3,$GLOBALS['lang']['Utilisateur_supprime']);
		else
			return redirect($GLOBALS['setting']['url_site'].'index.php?c=utilisateurAdmin',3,$GLOBALS['lang']['Utilisateur_erreur_supression'].'|warning');
	}
}