<?php
class Session extends controller
{
    /**
    * Contient les informations de sessions
    *
    * @var mixed
    */
    public $_session = array();

    /**
    * Contient les informations utilisateurs
    *
    * @var mixed
    */
    public $_utilisateur;

    public function check()
    {
        if( isset($_SESSION['session_id']) && isset($_SESSION['token']) && isset($_SESSION['utilisateur']) )
        {
            if($this->getNumberRow(PREFIX . 'session', " WHERE id = '". $_SESSION['session_id'] ."' AND token = '". $_SESSION['token'] ."' AND ip = '". base64_encode($_SERVER['REMOTE_ADDR']) ."'") == 1 )
            {
                $QueryArray = array(
                    'last_used' => time(),
                    'page'  =>  get_currentpage());

                $GLOBALS['db']->exec(CreateQueryUpdate($QueryArray, PREFIX .'session', " id = '". $_SESSION['session_id'] ."' AND token = '". $_SESSION['token'] ."' AND ip = '". base64_encode($_SERVER['REMOTE_ADDR']) ."'"));

                return true;
            }
            else
            {
                $this->delete($_SESSION['session_id']);
                session_destroy();
                return false;
            }
        }
        else
        {
            return false;
        }

    }


    /**
    * Creer une session utilsiateur
    *
    * @param mixed $user_id
    */
    public function create($user_id)
    {

        $_SESSION['utilisateur'] = array();

        // Verification si deja session
        if( isset($_SESSION['session_id']))
            $this->delete($_SESSION['session_id']);

        $_SESSION['token'] = md5(uniqid(rand(), true));         // Creation token
        $_SESSION['session_id'] = md5(uniqid(rand(), true));    // Creation session_id

        if( !is_null($user_id) && (int)$user_id && $user_id > 0):
            $this->deleteByUserId($user_id);
            $this->_utilisateur = $this->getUtilisateurInfo($user_id);
        endif;

        // Verification que le compte utilisateur soit actif
        if ( isset($this->_utilisateur['actif']) && $this->_utilisateur['actif'] == 0)
            redirect('identification.php?error=account_not_exist_or_desactived');

 
        // Stockage des infos utilisateurs
        foreach($this->_utilisateur as $key => $value):
            $_SESSION['utilisateur']['' . $key . ''] = $value;
        endforeach;

        $_SESSION['utilisateur_id'] = $user_id;
       

        $this->storeSession();
    }

    private function deleteByUserId($user_id)
    {
        $req = $GLOBALS['db']->prepare("DELETE FROM ". PREFIX ."session WHERE utilisateur_id = :user_id");
        $req->bindParam('user_id', $user_id, PDO::PARAM_INT);
        $req->execute();
    }

    /**
    * Stock la session dans la base de donnes
    *
    */
    private function storeSession()
    {

        $array = array(
        'id'    =>  $_SESSION['session_id'],
        'token' =>  $_SESSION['token'],
        'date_create'   =>  time(),
        'last_used' =>  time(),
        'ip'    =>  base64_encode($_SERVER['REMOTE_ADDR']),
        'page'  =>  get_currentpage(),
        'utilisateur_id'    =>  $_SESSION['utilisateur_id'],
        );

        $GLOBALS['db']->exec( CreateQueryInsert($array, PREFIX . 'session') );
    }

    /**
    * Recupere les informatiosn de l utilisateur
    *
    * @param mixed $user_id
    */
    private function getUtilisateurInfo($user_id)
    {
       // Verification utilisateur present dans la base
        if( !$this->checkUserExist($user_id) )
            redirect('identification.php?error=account_not_exist_or_desactived');

        // Recuperation info utilisateur
        $req = $GLOBALS['db']->prepare("SELECT id, identifiant, nom, prenom, actif, admin, alerte_stock, email FROM ". PREFIX ."utilisateur WHERE id = :user_id AND actif = 1 LIMIT 1");
        $req->bindParam('user_id', $user_id, PDO::PARAM_INT);
        $req->execute();
        $user = $req->fetch();

        $req->closeCursor();

        // Renvoie du resultat
        return $user;
    }

    /**
    * Verifie l exisance de l utilisateur dans la base de donnes
    *
    * @param mixed $user_id
    */
    private function checkUserExist($user_id)
    {
        $test = $this->getNumberRow(PREFIX . 'utilisateur', " WHERE id = ". (int)$user_id );

        if($test == 1)
            return true;
        else
            return false;
    }

    private function insert_new_session($token, $session_id)
    {
        $QueryArray = array(
        'id'    =>  $session_id,
        'token' =>  $token,
        'date_create'   =>  time(),
        'last_used' =>  time(),
        'ip'    =>  base64_encode($_SERVER['REMOTE_ADDR']),
        'page'  =>  get_currentpage());

        $GLOBALS['db']->exec(CreateQueryInsert($QueryArray, PREFIX .'session'));
    }

    /**
    * Supprime la session de la base de donnes
    *
    * @param mixed $session_id
    */
    private function delete($session_id)
    {
        $req = $GLOBALS['db']->prepare("DELETE FROM ". PREFIX ."session WHERE id = :session_id");
        $req->bindParam('session_id', $session_id, PDO::PARAM_STR);
        $req->execute();
    }

    /**
    * Supprime les sessions inactive de la base de donnes
    *
    */
    public function delete_session_time()
    {
        $time_delete = time()  - 1800;

        $req = $GLOBALS['db']->prepare("DELETE FROM ". PREFIX ."session WHERE last_used < :time_delete");
        $req->bindParam('time_delete', $time_delete, PDO::PARAM_INT);
        $req->execute();
    }

    /**
    * Verifie si l utilisateur est administrateur d immophp
    *
    * @param mixed $user_id
    */
    private function is_admin($user_id)
    {
        if($_SESSION['utilisateur_id'] == 1)
            return true;
        else
        {
           if($this->getNumberRow('groupe_user_link', " WHERE uid = ". $user_id ." AND gid = 1 ") == 1)
                return true;
            else
                return false;
        }
    }

    /**
    * Verifie si l utilisateur est administrateur d immophp
    *
    * @param mixed $user_id
    */
    /*public function check_admin()
    {
        if($_SESSION['administrateur'] == 'yes')
            return true;
        else
            return false;
    }*/

    public function checkCSRFget()
    {
        if($_GET['token'] == $_SESSION['token'])
            return true;
        else
            redirect('index.php');
    }

    public function checkCSRFpost()
    {
        if($_POST['token'] == $_SESSION['token'])
            return true;
        else
            redirect('index.php');
    }
}

?>
