<?php

class formulaire
{
    public $form_HTML;
    public $css_td;
    public $css_td_champ;
    public $css_tr;
    public $use_label;
    public $data;
    public $encar_data;
    
    public function __construct($new_form = true, $method = 'post', $action = '', $use_label = true, $css_tr = '', $css_td = '', $css_td_champ = '', $data = '')
    {
        $this->css_td = $css_td;
        $this->css_td_champ = $css_td_champ;
        $this->css_tr = $css_tr;
        $this->use_label = $use_label;
        $this->data = $data;
        
        // Cration du formulaire
        if($new_form === true)
        {
            $form_HTML .= '<form method='. $method .' action = '. $action .'>'; 
        }   
    }
    
    public function newChamp($champs)
    {
        $this->addLabel($champs);
        
        switch($champs['type'])
        {
            case 'text':
            $this->addText($champs);
            break;
            
            case 'lr':
            $this->addSelect($champs);
            break;
            
            case 'password':
            $this->addPassword($champs);
            break;
            
            case 'textarea':
            $this->addTextarea($champs);
            break;
        }
        
        $this->closeLabel();
    }
    
    public function addLabel($champ)
    {
        $this->form_HTML .= '<tr '. $this->css_tr .'><td '. $this->css_td .'>';
        
        if( $this->use_label === true)
        {
            $this->form_HTML .= '<label>'. $champ['label'] .'</label>';
        }
        
        $this->form_HTML .= '</td>';
    }
    
    public function closeLabel()
    {
        $this->form_HTML .= '</td></tr>';
    }
    
    /**
     * @desc : Ajoute un champ de type text au formulaire
     * @var : champ = array contenant les valeurs
     * */
    public function addText($champ)
    {
        $this->form_HTML .= '<td '. $this->css_td .'><input type="text" name="'. $champ['name'] .'" ';
        
        // Ajout de l id si renseigner
        if(isset($champ['id']) && $champ['id'] != '')
        {
            $this->form_HTML .= ' id="'. $champ['id'] .'" ';
        }
        
        // Ajout de la taille si renseigner
        if(isset($champ['size']) && $champ['size'] != '' && is_numeric($champ['size']))
        {
            $this->form_HTML .= ' size="'. $champ['size'] .'" ';
        }
        
        // Ajout valeur si renseigne
        if( isset($this->data[$champ['name_in_form']]) )
        {
            $this->form_HTML .= ' value="'. $this->data[$champ['name_in_form']] .'" '; 
        }
        else
        {
            $this->form_HTML .= ' value="'. $champ['value'] .'" ';   
        }
        
       
        $this->form_HTML .= ' />';
    }
    
    /**
     * @desc : Ajoute un champ de type password au formulaire
     * @var : champ = array contenant les valeurs
     * */
    public function addPassword($champ)
    {
        $this->form_HTML .= '<td '. $this->css_td .'><input type="password" name="'. $champ['name'] .'" ';
        
        // Ajout de l id si renseigner
        if(isset($champ['id']) && $champ['id'] != '')
        {
            $this->form_HTML .= ' id="'. $champ['id'] .'" ';
        }
        
        // Ajout de la taille si renseigner
        if(isset($champ['size']) && $champ['size'] != '' && is_numeric($champ['size']))
        {
            $this->form_HTML .= ' size="'. $champ['size'] .'" ';
        }
        
        // Ajout valeur si renseigne
        if( isset($this->data[$champ['name_in_form']]) )
        {
            $this->form_HTML .= ' value="'. $this->data[$champ['name_in_form']] .'" '; 
        }
        else
        {
            $this->form_HTML .= ' value="'. $champ['value'] .'" ';   
        }
        
       
        $this->form_HTML .= ' />'; 
    }
    
    /**
     * @desc : Ajoute une zone de saisie large au formulaire
     * @var : champ = array contenant les valeurs
     * */
    public function addTextarea($champ)
    {
        $this->form_HTML .= '<td '. $this->css_td .'><textarea name="'. $champ['name'] .'" ';
        
        // Ajout de l id si renseigner
        if(isset($champ['id']) && $champ['id'] != '')
        {
            $this->form_HTML .= ' id="'. $champ['id'] .'" ';
        }
        
        // Traitement largeur et hauteur
        if(isset($champ['rows']) && is_numeric($champ['rows']) && $champ['rows'] != '' &&  $champ['rows'] != 0)
        {
            $this->form_HTML .= ' rows="'. $champ['rows'] .'" ';
        }
        
        if(isset($champ['cols']) && is_numeric($champ['cols']) && $champ['cols'] != '' && $champ['cols'] != 0)
        {
            $this->form_HTML .= ' cols="'. $champ['cols'] .'" ';
        }
        
        // Fermeture de la textarea part 1
        $this->form_HTML .= ' >';
        
        // Traitement de la valeur par defaut
        if( isset($champ['value']) && $champ['value'] != '' )
        {
            $this->form_HTML .= $champ['value'];
        }
        
        // Fermeture du champ
        $this->form_HTML .= '</textarea>';   
        
    }
    
    
    public function addSelect($champ)
    {
        $this->form_HTML .= '<td '. $this->css_td .'><select name="'. $champ['name'] .'" ';
        
        // Ajout de l id si renseigner
        if(isset($champ['id']) && $champ['id'] != '')
        {
            $this->form_HTML .= ' id="'. $champ['id'] .'" ';
        }
        
        // Fermeture balise ouverture
        $this->form_HTML .= ' >';
        
        /**
         * Traitement des options
         * Elles doivent etre passer sous forme d'array
         * pour le valeur par defaut, elle doit etre passer pas le champ value qui doit correspondre  l a valeur donner
         * */
         $options = unserialize($champ['options']);
         
         foreach($options as $key)
         {
            $this->form_HTML .= '<option value="'. $key .'"';

            // Verification si champ selectionner
            if( isset($this->data[$champ['name_in_form']]) && $this->data[$champ['name_in_form']] == $key)
            {
                $this->form_HTML .= ' selected="selected" ';
            }
            
            // Fermeture de la balise d ouverture
            $this->form_HTML .= ' >';
            
            // Affichage de la valeur
            $this->form_HTML .= $key;
            
            // Fermeture de l option
            $this->form_HTML .= '</option>';
         }
         
         // Fermeture du select
         $this->form_HTML .= '</select>';
    }
    
    /**
     * @desc Option possibilite d ajouter un champ CKEDITOR
     * */
}