<?php

$query = array();

/**
--
-- Structure de la table auth_client
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."auth_client (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  voir int(1) NOT NULL DEFAULT '1',
  ajout int(1) NOT NULL DEFAULT '1',
  edit int(1) NOT NULL DEFAULT '1',
  del int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (id),
  UNIQUE KEY user_id (user_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1";
/**
--
-- Structure de la table auth_mailing
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."auth_mailing (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  ajout int(11) NOT NULL DEFAULT '0',
  del int(11) NOT NULL DEFAULT '0',
  envoyer int(11) NOT NULL DEFAULT '0',
  modif int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1";
/**
--
-- Structure de la table auth_mdj
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."auth_mdj (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  ajout int(1) NOT NULL DEFAULT '0',
  modif int(1) NOT NULL DEFAULT '0',
  del int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (id),
  UNIQUE KEY user_id (user_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table auth_ticket
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."auth_ticket (
  id int(11) NOT NULL AUTO_INCREMENT,
  user_id int(11) NOT NULL,
  ajout int(1) NOT NULL DEFAULT '1',
  modif int(1) NOT NULL DEFAULT '1',
  del int(1) NOT NULL DEFAULT '0',
  attribuer int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table client
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."client (
  id int(11) NOT NULL AUTO_INCREMENT COMMENT 'identifiant client dans la base',
  nom varchar(150) NOT NULL,
  prenom varchar(150) NOT NULL,
  societe varchar(200) NOT NULL,
  numero_client varchar(100) NOT NULL,
  adresse text NOT NULL,
  code_postal varchar(50) NOT NULL,
  ville varchar(200) NOT NULL,
  pays varchar(200) NOT NULL,
  telephone varchar(200) NOT NULL,
  fax varchar(200) NOT NULL,
  portable varchar(200) NOT NULL,
  categorie_id int(11) NOT NULL,
  mailing int(2) NOT NULL,
  site_web varchar(200) NOT NULL,
  email varchar(200) NOT NULL,
  contact text NOT NULL,
  user_add int(11) NOT NULL,
  password varchar(200) NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  view int(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table client_categorie
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."client_categorie (
  id int(11) NOT NULL AUTO_INCREMENT,
  titre varchar(150) NOT NULL,
  description text NOT NULL,
  photo varchar(255) NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  date_modif timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table client_commentaire
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."client_commentaire (
  id int(11) NOT NULL AUTO_INCREMENT,
  client_id int(10) NOT NULL,
  user_id int(10) NOT NULL,
  commentaire text NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table client_log
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."client_log (
  id int(11) NOT NULL AUTO_INCREMENT,
  client_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  action varchar(200) NOT NULL,
  date_action timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table client_rdv
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."client_rdv (
  id int(11) NOT NULL AUTO_INCREMENT,
  client_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  date_prise_rdv date NOT NULL,
  date_rdv datetime NOT NULL,
  sujet_rdv varchar(255) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table config
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."config (
  nom varchar(30) NOT NULL,
  valeur text NOT NULL,
  PRIMARY KEY (nom)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
/**
--
-- Contenu de la table config
--
**/
$query[] = "
INSERT INTO ". PREFIX ."config (nom, valeur) VALUES
('client_fichier', '1'),
('client_rendezvous', '1'),
('client_carte', '1'),
('client_commentaire', '1'),
('version', '2.20101011'),
('ticket_historique', '1'),
('ticket_intervention_demande', '1'),
('titre', 'InfoGest V2'),
('key_google_map', ''),
('nom_societe', ''),
('adresse_societe', ''),
('telephone_1', ''),
('telephone_2', ''),
('fax', ''),
('email', ''),
('siteweb', ''),
('mail_method', 'smtp'),
('smtp_server', ''),
('smtp_port', ''),
('smtp_login', ''),
('smtp_password', ''),
('email_signature_html', ''),
('email_signature', ''),
('mailing_email', ''),
('mailing_signature_html', ''),
('mailing_signature', '');";
/**
--
-- Structure de la table formulaire_champ
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."formulaire_champ (
  idf int(11) NOT NULL AUTO_INCREMENT,
  formulaire_name varchar(100) NOT NULL,
  formulaire_id int(11) NOT NULL,
  label varchar(100) NOT NULL,
  type varchar(30) NOT NULL,
  value varchar(255) NOT NULL,
  options text NOT NULL,
  size int(3) NOT NULL,
  name varchar(100) NOT NULL,
  name_in_form varchar(200) NOT NULL,
  id varchar(100) NOT NULL,
  rows int(3) NOT NULL,
  cols int(3) NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  date_modif timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (idf)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table mailing
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."mailing (
  id int(11) NOT NULL AUTO_INCREMENT,
  auteur_id int(11) DEFAULT NULL,
  categorie_id int(11) DEFAULT NULL,
  titre varchar(150) DEFAULT NULL,
  texte text,
  texte_html text NOT NULL,
  date_ajout timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  envoye int(1) NOT NULL DEFAULT '0',
  liste_construit int(11) NOT NULL DEFAULT '0',
  date_envoie timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table mailing_destinataire
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."mailing_destinataire (
  id int(11) NOT NULL AUTO_INCREMENT,
  mailing_id int(11) NOT NULL,
  client_id int(11) NOT NULL,
  client_email varchar(200) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table mot_du_jour
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."mot_du_jour (
  id int(11) NOT NULL AUTO_INCREMENT,
  auteur_id int(11) NOT NULL,
  titre varchar(150) NOT NULL,
  texte text NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  date_fin date NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table session
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."session (
  id varchar(150) NOT NULL,
  token varchar(150) NOT NULL,
  date_create int(50) NOT NULL,
  last_used int(11) NOT NULL,
  ip varchar(100) NOT NULL,
  page varchar(100) NOT NULL,
  utilisateur_id int(15) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
/**
--
-- Structure de la table ticket
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket (
  id int(11) NOT NULL AUTO_INCREMENT,
  client_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  categorie_id int(11) NOT NULL,
  titre varchar(150) NOT NULL,
  description text NOT NULL,
  priorite int(2) NOT NULL,
  statut int(2) NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  user_attrib int(11) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_categorie
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_categorie (
  id int(11) NOT NULL AUTO_INCREMENT,
  nom varchar(100) NOT NULL,
  description text NOT NULL,
  photo varchar(150) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_historique
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_historique (
  id int(11) NOT NULL AUTO_INCREMENT,
  ticket_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  action text NOT NULL,
  date_action timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_intervention
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_intervention (
  id int(11) NOT NULL AUTO_INCREMENT,
  type_id int(11) NOT NULL,
  ticket_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  description text NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  demande_id int(11) NOT NULL DEFAULT '0' COMMENT 'id de la demande intervention',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_intervention_demande
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_intervention_demande (
  id int(11) NOT NULL AUTO_INCREMENT,
  type_id int(11) NOT NULL,
  ticket_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  date_prevu datetime NOT NULL,
  description text NOT NULL,
  intervention_id int(11) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_intervention_type
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_intervention_type (
  id int(11) NOT NULL AUTO_INCREMENT COMMENT 'identifiant',
  nom varchar(200) NOT NULL COMMENT 'nom du tyoe',
  description text NOT NULL COMMENT 'Description',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table ticket_suivi
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."ticket_suivi (
  id int(11) NOT NULL AUTO_INCREMENT,
  ticket_id int(11) NOT NULL,
  user_id int(11) NOT NULL,
  suivi text NOT NULL,
  date_ajout timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
/**
--
-- Structure de la table utilisateur
--
**/
$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."utilisateur (
  id int(11) NOT NULL AUTO_INCREMENT,
  identifiant varchar(100) NOT NULL,
  password varchar(255) NOT NULL,
  email varchar(200) NOT NULL,
  nom varchar(100) NOT NULL,
  prenom varchar(100) NOT NULL,
  poste varchar(150) NOT NULL,
  photo varchar(200) NOT NULL,
  actif int(1) NOT NULL DEFAULT '0',
  admin int(1) NOT NULL DEFAULT '0',
  last_used int(30) NOT NULL,
  date_anniversaire date NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;";
/**
--
-- Contenu de la table utilisateur
--
**/
$query[] = "
INSERT INTO ". PREFIX ."utilisateur (id, identifiant, password, email, nom, prenom, poste, photo, actif, admin, last_used, date_anniversaire) VALUES
(1, 'admin', 'd033e22ae348aeb5660fc2140aec35850c4da997', '', 'admin', 'admin', '', '', 1, 1, 0, '0000-00-00');";

/**
*	AJOUT DES MODIFICATION POUR LA VERSION 2.20101011
*/
$query[] = "
CREATE TABLE ". PREFIX ."prospect (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
nom VARCHAR( 200 ) NOT NULL ,
prenom VARCHAR( 200 ) NOT NULL ,
societe VARCHAR( 200 ) NOT NULL ,
contact TEXT NOT NULL ,
adresse TEXT NOT NULL ,
code_postal VARCHAR( 50 ) NOT NULL ,
ville VARCHAR( 200 ) NOT NULL ,
pays VARCHAR( 200 ) NOT NULL ,
telephone VARCHAR( 30 ) NOT NULL ,
portable VARCHAR( 30 ) NOT NULL ,
fax VARCHAR( 30 ) NOT NULL ,
email VARCHAR( 200 ) NOT NULL ,
site_web VARCHAR( 200 ) NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
user_add INT NOT NULL ,
client_id INT NOT NULL DEFAULT '0',
categorie_id INT NOT NULL DEFAULT '0'
) ENGINE = MYISAM ;";

$query[] = "ALTER TABLE ". PREFIX ."client ADD parent_id INT NOT NULL DEFAULT '0';";

$query[] = "
CREATE TABLE ". PREFIX ."prospect_methode_contact (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
nom VARCHAR( 200 ) NOT NULL ,
description TEXT NOT NULL ,
photo VARCHAR( 200 ) NOT NULL
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."prospection (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
methode_id INT NOT NULL DEFAULT '0',
description TEXT NOT NULL ,
prospect_id INT NOT NULL DEFAULT '0',
client_id INT NOT NULL DEFAULT '0',
user_id INT NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."prospect_suivi (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
prospect_id INT NOT NULL ,
user_id INT NOT NULL ,
suivi TEXT NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."auth_prospect (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
user_id INT NOT NULL ,
ajout INT( 1 ) NOT NULL DEFAULT '1',
modif INT NOT NULL DEFAULT '1',
del INT NOT NULL DEFAULT '0'
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."tache (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
user_id INT NOT NULL ,
controller VARCHAR( 100 ) NOT NULL ,
controller_id INT NOT NULL ,
action TEXT NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "ALTER TABLE ". PREFIX ."tache ADD realise INT NOT NULL DEFAULT '0'";

$query[] = "
CREATE TABLE ". PREFIX ."fournisseur (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
numero VARCHAR( 50 ) NOT NULL ,
categorie_id INT NOT NULL ,
nom VARCHAR( 150 ) NOT NULL ,
adresse VARCHAR( 250 ) NOT NULL ,
code_postal VARCHAR( 50 ) NOT NULL ,
ville VARCHAR( 200 ) NOT NULL ,
pays VARCHAR( 150 ) NOT NULL ,
telephone_1 VARCHAR( 25 ) NOT NULL ,
telephone_2 VARCHAR( 25 ) NOT NULL ,
fax VARCHAR( 25 ) NOT NULL ,
email VARCHAR( 200 ) NOT NULL ,
site_internet VARCHAR( 200 ) NOT NULL ,
siret VARCHAR( 60 ) NOT NULL ,
rcs VARCHAR( 60 ) NOT NULL ,
numero_tva VARCHAR( 60 ) NOT NULL ,
capital VARCHAR( 60 ) NOT NULL ,
forme_juridique VARCHAR( 200 ) NOT NULL
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."fournisseur_categorie (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
nom VARCHAR( 100 ) NOT NULL ,
description TEXT NOT NULL ,
photo VARCHAR( 200 ) NOT NULL
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."fournisseur_commercial (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
fournisseur_id INT NOT NULL ,
nom VARCHAR( 100 ) NOT NULL ,
prenom VARCHAR( 100 ) NOT NULL ,
telephone VARCHAR( 20 ) NOT NULL ,
portable VARCHAR( 20 ) NOT NULL ,
email VARCHAR( 150 ) NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."auth_fournisseur (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
user_id INT NOT NULL ,
voir INT( 1 ) NOT NULL DEFAULT '0',
ajout INT( 1 ) NOT NULL DEFAULT '0',
modif INT( 1 ) NOT NULL DEFAULT '0',
del INT( 1 ) NOT NULL DEFAULT '0'
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."produit (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
categorie_id INT NOT NULL ,
reference VARCHAR( 50 ) NOT NULL ,
nom VARCHAR( 200 ) NOT NULL ,
description TEXT NOT NULL ,
tva INT( 2 ) NOT NULL ,
prix_vente FLOAT NOT NULL ,
photo VARCHAR( 150 ) NOT NULL ,
stock_alerte INT( 10 ) NOT NULL ,
stock_critique INT( 10 ) NOT NULL ,
stock INT NOT NULL DEFAULT '0',
poid VARCHAR( 10 ) NOT NULL ,
longueur VARCHAR( 10 ) NOT NULL ,
largeur VARCHAR( 10 ) NOT NULL ,
constructeur VARCHAR( 200 ) NOT NULL
) ENGINE = MYISAM ;";

$query[] = "
ALTER TABLE ". PREFIX ."produit ADD poid_unite VARCHAR( 30 ) NOT NULL ,
ADD longueur_unite VARCHAR( 30 ) NOT NULL ,
ADD largeur_unite VARCHAR( 30 ) NOT NULL";

$query[] = "
CREATE TABLE ". PREFIX ."produit_fournisseur (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
produit_id INT NOT NULL ,
fournisseur_id INT NOT NULL ,
prix FLOAT NOT NULL ,
reference VARCHAR( 100 ) NOT NULL
) ENGINE = MYISAM ;";

$query[] = "ALTER TABLE ". PREFIX ."produit_fournisseur ADD quantite INT NOT NULL";

$query[] = "CREATE TABLE ". PREFIX ."produit_entre (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
produit_id INT NOT NULL ,
user_id INT NOT NULL ,
quantite FLOAT NOT NULL ,
raison TEXT NOT NULL ,
date_entre TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."produit_sortie (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
produit_id INT NOT NULL ,
user_id INT NOT NULL ,
quantite FLOAT NOT NULL ,
raison TEXT NOT NULL ,
date_sortie TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = MYISAM ;";

$query[] = "
CREATE TABLE ". PREFIX ."auth_produit (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
user_id INT NOT NULL ,
ajout INT( 1 ) NOT NULL DEFAULT '0',
modif INT( 1 ) NOT NULL DEFAULT '0',
del INT( 1 ) NOT NULL DEFAULT '0',
voir_prix_vente INT( 1 ) NOT NULL DEFAULT '0',
voir_prix_achat INT( 1 ) NOT NULL DEFAULT '0',
ajout_entree INT( 1 ) NOT NULL DEFAULT '0',
ajout_sortie INT( 1 ) NOT NULL DEFAULT '1'
) ENGINE = MYISAM ;";

$query[] = "ALTER TABLE ". PREFIX ."utilisateur ADD alerte_stock INT( 1 ) NOT NULL DEFAULT '0'";

$query[] = "
CREATE TABLE ". PREFIX ."alerte (
id INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
user_id INT NOT NULL ,
controller VARCHAR( 100 ) NOT NULL ,
controller_id INT NOT NULL ,
titre VARCHAR( 150 ) NOT NULL ,
description TEXT NOT NULL ,
date_ajout TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ,
lu INT( 1 ) NOT NULL DEFAULT '0'
) ENGINE = MYISAM ;";

$query[] = "ALTER TABLE ". PREFIX ."fournisseur ADD numero_client VARCHAR( 50 ) NOT NULL";

$query[] = "ALTER TABLE ". PREFIX ."client ADD siret VARCHAR( 100 ) NOT NULL ,
ADD numero_tva VARCHAR( 100 ) NOT NULL ,
ADD rcs VARCHAR( 100 ) NOT NULL ,
ADD type INT( 2 ) NOT NULL"; 

$query[] = "
CREATE TABLE IF NOT EXISTS ". PREFIX ."produit_categorie (
  id int(11) NOT NULL AUTO_INCREMENT,
  parent_id int(11) NOT NULL DEFAULT '0',
  nom varchar(255) NOT NULL,
  description text NOT NULL,
  photo varchar(200) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;";
