<?php
class clientAdminModel
{
    public function saveChamp($data)
    {
        // Preparation pour le nom
        $nomchamp = trim($data['name']);
        $nomchamp = str_replace(' ','',$nomchamp);
        $nomchamp = strtr($nomchamp, '', 'AAAAAACEEEEEIIIINOOOOOUUUUY');
        $nomchamp = strtr($nomchamp, '', 'aaaaaaceeeeiiiinooooouuuuyy');
        
        // Formatage pour nom dans formulaire
        $data['name'] = 'client['. $nomchamp .']';
		
		// Enregistrement du nom dans la base
		$data['name_in_form'] = $nomchamp;
                
        //Preparation des donnes
        if($data['type'] == 'lr')
        {
            // Mise en forme des options
            $options = explode(';',$data['options']);
            $data['options'] = serialize($options);
        }
        
        if( $GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'formulaire_champ')) )
        {
            // Ajout du champ dans la table
            $GLOBALS['db']->exec("ALTER TABLE ". PREFIX ."client ADD ". $nomchamp ." TEXT NOT NULL");
            return true;
        }
        else
        {
            return false;
        }
    }
	
	public function champ_edit($data)
	{
		if( isset($data['options']) && $data['options'] != '')
		{
			$options = explode(';', $data['options']);
			$data['options'] = serialize($options);
		}

		if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'formulaire_champ', " idf = ". $data['idf'])) )
			return true;
		else
			return false;		
	}
	
	public function champ_delete($data)
	{
		if( $GLOBALS['db']->exec("DELETE FROM ". PREFIX ."formulaire_champ WHERE idf = ". $data['idf']) )
		{
			// Suppression du champ de la table clienbt
			if( $GLOBALS['db']->exec("ALTER TABLE ". PREFIX ."client DROP ". $data['name_in_form'] ."") )
				return true;
			else
				return false;
		}
		else
			return false;
	}
	
    /**
	*	@desc retourne les informations du champ passer a la fonction
	*	@id integer
	* */	
	public function getChampById($id)
	{
		$req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."formulaire_champ WHERE formulaire_name = 'client' AND idf = :champ_id");
		$req->bindParam('champ_id', $id, PDO::PARAM_INT);
		$req->execute();
		$res = $req->fetch();
		$req->closeCursor();
		
		// Traitement des options
		if($res['options'] != ''):
			$opt = unserialize($res['options']);
			$res['options'] = '';
			
			foreach($opt as $k):
				$res['options'] .= $k.';';
			endforeach;
			
			$res['options'] = substr($res['options'],0,-1);
		endif;
		
		return $res;
	}
	
    public function getChamp()
    {
        $req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."formulaire_champ WHERE formulaire_name = 'client' ORDER BY label");
        $req->execute();
        return $req->fetchAll();
    }
//--- CATEGORIE ---//	
	public function getAllCategorie()
	{
		$req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."client_categorie ORDER BY titre");
		$req->execute();
		return $req->fetchAll();
	}
    
    public function categorie_save($data)
    {
        if( $GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'client_categorie')) )
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public function categorie_edit($data)
    {
        //echo CreateQueryUpdate($data, PREFIX . 'client_categorie', " id = ". $data['id']);
        //exit;
        if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'client_categorie', " id = ". $data['id']) ))
        {
            return true;
        }
        else
            return false;
    }
    
    /**
     * @desc Supprime la categorie de la base et remet  0 les clients de cette catgorie
     * @id integer id de la categorie  supprim
     * */
    public function categorie_delete($id)
    {
        $req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'client_categorie WHERE id = :categorie_id');
        $req->bindParam('categorie_id', $id, PDO::PARAM_INT);
        $req->execute();
        
        // Suppression des utilisateurs dans cette cateorie
        $GLOBALS['db']->exec(" UPDATE ". PREFIX ."client SET categorie_id = '' WHERE categorie_id = '". $id ."' ");
    }
    
    public function getCategorieById($id)
    {
        $req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."client_categorie WHERE id = :categorie_id LIMIT 1");
        $req->bindParam('categorie_id', $id, PDO::PARAM_INT);
        $req->execute();
        $res = $req->fetch();
        $req->closeCursor();
        return $res;
    }
	
	public function getAuthByUser($utilisateur_id)
	{
		$req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."auth_client WHERE user_id = :utilisateur_id");
		$req->bindParam('utilisateur_id', $utilisateur_id, PDO::PARAM_INT);
		$req->execute();
		
		// Recuperation du resultat
		$res = $req->fetch();
		
		// Fermeture du curseur
		$req->closeCursor();
		
		return $res;
	}
	
	/**
	* Force la mise a jour des droits utilisateurs
	* */
	public function UpdateAuthByUser($utilisateur_id)
	{
		$GLOBALS['db']->exec("INSERT INTO ". PREFIX ."auth_client (user_id) VALUES (". $utilisateur_id .")");
	}
	
	/**
	*	@desc met  jours les authorisations dans la base de donnees
	*	@data array contenantles donnes
	* */
	public function updateAuth($data)
	{
	//echo CreateQueryUpdate($data, PREFIX . 'auth_client', " id = ". $data['id'] ." AND user_id = ". $data['user_id']);
	//exit;
		if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'auth_client', " id = ". $data['id'] ." AND user_id = ". $data['user_id'])) )
			return true;
		else
			return false;
	}
}