<?php
class fournisseurModel extends model
{
    public function getAll()
    {
        $req = $GLOBALS['db']->prepare('
            SELECT tf.*, tfc.nom AS categorie
            FROM '. PREFIX .'fournisseur tf
            LEFT JOIN '. PREFIX .'fournisseur_categorie tfc
                ON tf.categorie_id = tfc.id
            ORDER BY nom');
        $req->execute();
        return $req->fetchAll();
    }

    public function getCategorie()
    {
        $req = $GLOBALS['db']->prepare('SELECT tc.* FROM '. PREFIX .'fournisseur_categorie tc ORDER BY tc.nom');
        $req->execute();
        return $req->fetchAll();
    }

    public function getById($id)
    {
        $req = $GLOBALS['db']->prepare('
            SELECT tf.*, tfc.nom AS categorie
            FROM '. PREFIX .'fournisseur tf
            LEFT JOIN '. PREFIX .'fournisseur_categorie tfc
                ON tf.categorie_id = tfc.id
            WHERE tf.id = :id
            LIMIT 1');
        $req->bindParam('id', $id, PDO::PARAM_INT);
        $req->execute();
        $result =  $req->fetch();
        $req->closeCursor();
        return $result;
    }

    public function getCommercialByFournisseur($fournisseur_id)
    {
        $req = $GLOBALS['db']->prepare('SELECT * FROM '. PREFIX .'fournisseur_commercial WHERE fournisseur_id = :fournisseur_id ORDER BY nom, prenom');
        $req->bindParam('fournisseur_id', $fournisseur_id, PDO::PARAM_INT);
        $req->execute();
        return $req->fetchAll();
    }

    public function getProduits($fournisseur_id)
    {
        $req = $GLOBALS['db']->prepare('
            SELECT tpf.*, tp.nom AS produit_nom, tp.reference AS produit_reference
            FROM '. PREFIX .'produit_fournisseur tpf
                LEFT JOIN '. PREFIX .'produit tp ON tpf.produit_id = tp.id
            WHERE fournisseur_id = :fournisseur_id
            ORDER BY tp.nom');
        $req->bindParam('fournisseur_id', $fournisseur_id, PDO::PARAM_INT);
        $req->execute();
        return $req->fetchAll();
    }

}