<?php

class mailingModel
{
	public function getAll($order_by = ' date_ajout DESC ')
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tm.id, tm.titre, tm.date_ajout, tm.categorie_id, tu.identifiant, tcc.titre AS categorie_nom, tm.date_envoie, tm.envoye
			FROM '. PREFIX .'mailing tm
			LEFT JOIN '. PREFIX .'utilisateur tu 
				ON tm.auteur_id = tu.id
			LEFT JOIN '. PREFIX .'client_categorie tcc
				ON tm.categorie_id = tcc.id
			ORDER BY '. $order_by .' ');
		$req->execute();
		return $req->fetchAll();
	}	
	
	public function getById($mailing_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tm.id, tm.titre, tm.date_ajout, tm.categorie_id, tu.identifiant, tcc.titre AS categorie_nom, texte, texte_html, envoye, liste_construit, date_envoie
			FROM '. PREFIX .'mailing tm
			LEFT JOIN '. PREFIX .'utilisateur tu 
				ON tm.auteur_id = tu.id
			LEFT JOIN '. PREFIX .'client_categorie tcc
				ON tm.categorie_id = tcc.id
			WHERE tm.id = :mailing_id LIMIT 1');
		$req->bindParam('mailing_id', $mailing_id, PDO::PARAM_INT);
		$req->execute();
		$res = $req->fetch();
		$req->closeCursor();
		return $res;
	}
	
	public function add($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'mailing')) )
			return true;
		else
			return false;
	}
	
	public function edit($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'mailing', " id = ". $data['id'])) )
			return true;
		else
			return false;
	}
	
	public function ConstructEmailListe($and, $mailing_id)
	{
		// Supression de la liste si presente
		$GLOBALS['db']->exec('DELETE FROM '. PREFIX .'mailing_destinataire WHERE mailing_id = '. $mailing_id);
	
		// Recuperation des emails
		$req = $GLOBALS['db']->prepare('
			SELECT DISTINCT(email), id
			FROM '. PREFIX .'client
			WHERE email != ""
			AND mailing = 1
			'. $and);
		$req->execute();
		$result = $req->fetchAll();
		
		// Enregistrement des email
		$req = $GLOBALS['db']->prepare('INSERT INTO '. PREFIX .'mailing_destinataire (mailing_id, client_id, client_email) VALUES(:mailing_id, :client_id, :client_email) ');
		
		foreach($result as $client)
		{
			$req->bindParam('mailing_id', $mailing_id, PDO::PARAM_INT);
			$req->bindParam('client_id', $client['id'], PDO::PARAM_INT);
			$req->bindParam('client_email', $client['email'], PDO::PARAM_STR);
			$req->execute();
		}
		
		// Mise a jour mailing
		$req = $GLOBALS['db']->prepare('UPDATE '. PREFIX .'mailing SET liste_construit = 1 WHERE id = :mailing_id');
		$req->bindParam('mailing_id', $mailing_id, PDO::PARAM_INT);
		$req->execute();		
	}
	
	public function setMailingSended($mailing_id)
	{
		$GLOBALS['db']->exec( "UPDATE ". PREFIX ."mailing SET date_envoie = NOW(), envoye = 1 WHERE id = ". $mailing_id ."");
	}
	
	public function getEmailForSend($mailing_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT client_email
			FROM '. PREFIX .'mailing_destinataire
			WHERE mailing_id = :mailing_id');
		$req->bindParam('mailing_id', $mailing_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function delete($mailing_id)
	{
		$GLOBALS['db']->exec("DELETE FROM ". PREFIX ."mailing_destinataire WHERE mailing_id = ". $mailing_id ."");
		
		if( $GLOBALS['db']->exec("DELETE FROM ". PREFIX ."mailing WHERE id = ". $mailing_id ."") )
			return true;
		else
			return false;
	}
}
?>