<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
class produitModel extends model
{
    public function getAll($table = '', $limit = 50, $offset = 0, $param = '')
    {
        if( $table != '')
            return parent::getAll($table);
        else
        {
            $req = $GLOBALS['db']->query('
                SELECT tp.*, tpc.nom AS categorie, tpc2.nom AS categorie_parent
                FROM '. PREFIX .'produit tp
                LEFT JOIN '. PREFIX .'produit_categorie tpc
                    ON tp.categorie_id = tpc.id
                LEFT JOIN '. PREFIX .'produit_categorie tpc2
                    ON tpc.parent_id = tpc2.id
                WHERE 1
                '. $param . '
                ORDER BY nom
                LIMIT '. $limit .'
                OFFSET '. $offset);
            return $req->fetchAll();
        }
    }

    public function getById($id, $table = '')
    {
        if( $table != '')
            return parent::getById ($id, $table);
        else
        {
            $req = $GLOBALS['db']->query('
                SELECT tp.*, tpc.nom AS categorie, tpc2.nom AS categorie_parent
                FROM '. PREFIX .'produit tp
                LEFT JOIN '. PREFIX .'produit_categorie tpc
                    ON tp.categorie_id = tpc.id
                LEFT JOIN '. PREFIX .'produit_categorie tpc2
                    ON tpc.parent_id = tpc2.id
                WHERE tp.id = '. $id .'
                LIMIT 1');
            $res = $req->fetch(PDO::FETCH_ASSOC);
            $req->closeCursor();
            return $res;
        }
    }


    public function getNbProduit()
    {
        return parent::getNumberRow(PREFIX . 'produit','');
    }

    public function getCategorie($recursive = false)
    {
       $req =  $GLOBALS['db']->query('SELECT * FROM '. PREFIX .'produit_categorie ORDER BY nom');

       if($recursive == false)
       {
           return $req->fetchAll();
       }
       elseif($recursive == true)
       {
           return constructRecusive(0,0,$req->fetchAll());
       }
    }

    public function getProduitFournisseur($produit_id)
    {
        $req = $GLOBALS['db']->prepare('
            SELECT tpf.*, tf.nom AS fournisseur
            FROM '. PREFIX .'produit_fournisseur tpf
            LEFT JOIN '. PREFIX .'fournisseur tf
                ON tpf.fournisseur_id = tf.id
            WHERE produit_id = :produit_id
            ORDER BY tf.nom, quantite');
        $req->bindParam('produit_id', $produit_id, PDO::PARAM_INT);
        $req->execute();
        return $req->fetchAll();
    }

    public function getSortie($produit_id, $limit = '')
    {
        $query = 'SELECT tps.*, tu.identifiant FROM '. PREFIX .'produit_sortie tps LEFT JOIN '. PREFIX .'utilisateur tu ON tps.user_id = tu.id WHERE produit_id = :produit_id ORDER BY date_sortie DESC';

        if( $limit != '' && is_numeric($limit) )
            $query .= ' LIMIT '. $limit;

        $req = $GLOBALS['db']->prepare($query);
        $req->bindParam('produit_id', $produit_id , PDO::PARAM_INT);
        $req->execute();
        return $req->fetchAll();
    }

    public function getEntree($produit_id, $limit = '')
    {
       $query = 'SELECT tpe.*, tu.identifiant FROM '. PREFIX .'produit_entre tpe LEFT JOIN '. PREFIX .'utilisateur tu ON tpe.user_id = tu.id WHERE produit_id = :produit_id ORDER BY date_entre DESC';

        if( $limit != '' && is_numeric($limit) )
            $query .= ' LIMIT '. $limit;

        $req = $GLOBALS['db']->prepare($query);
        $req->bindParam('produit_id', $produit_id , PDO::PARAM_INT);
        $req->execute();
        return $req->fetchAll();
    }

    public function delete_produit_link($produit_id)
    {
        $GLOBALS['db']->exec(" DELETE FROM ". PREFIX ."produit_entre WHERE produit_id = ". $produit_id);
        $GLOBALS['db']->exec(" DELETE FROM ". PREFIX ."produit_sortie WHERE produit_id = ". $produit_id);
        $GLOBALS['db']->exec(" DELETE FROM ". PREFIX ."produit_fournisseur WHERE produit_id = ". $produit_id);
    }

    public function getUserAlerte()
    {
        $req = $GLOBALS['db']->query('SELECT id, email FROM '. PREFIX .'utilisateur WHERE alerte_stock = 1');
        return $req->fetchAll();
    }

    public function getFournisseur()
    {
        $req = $GLOBALS['db']->prepare('SELECT id, nom FROM '. PREFIX .'fournisseur ORDER BY nom');
        $req->execute();
        return $req->fetchAll();
    }
}
?>
