<?php

class prospectModel extends model
{
	public function getAll($limit = 50, $offset = 0)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tp.*, tcc.titre AS categorie
			FROM '. PREFIX .'prospect tp
			LEFT JOIN '. PREFIX .'client_categorie tcc 
				ON tp.categorie_id = tcc.id
			LIMIT '. $limit .' OFFSET '. $offset .'
		');
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getById($id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tp.*, tcc.titre AS categorie, tu.identifiant
			FROM '. PREFIX .'prospect tp
			LEFT JOIN '. PREFIX .'client_categorie tcc 
				ON tp.categorie_id = tcc.id
			LEFT JOIN '. PREFIX .'utilisateur tu
				ON tp.user_add = tu.id
			WHERE tp.id = :id
			LIMIT 1');
		$req->bindParam('id', $id, PDO::PARAM_INT);
		$req->execute();
		$result = $req->fetch();
		$req->closeCursor();
		return $result;		
	}
	
	public function getProspectionByProspect($prospect_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tp.*, tu.identifiant, tpmc.nom as methode
			FROM '. PREFIX .'prospection tp
			LEFT JOIN '. PREFIX .'prospect_methode_contact tpmc
				ON tp.methode_id = tpmc.id
			LEFT JOIN '. PREFIX .'utilisateur tu
				ON tp.user_id = tu.id
			WHERE prospect_id = :prospect_id
			ORDER BY date_ajout DESC
			');
		$req->bindParam('prospect_id', $prospect_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getSuiviByProspect($prospect_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tps.*, tu.identifiant 
			FROM '. PREFIX .'prospect_suivi tps
			LEFT JOIN '. PREFIX .'utilisateur tu
				ON tps.user_id = tu.id
			WHERE prospect_id = :prospect_id
			ORDER BY date_ajout DESC'); 
		$req->bindParam('prospect_id', $prospect_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function checkTelephone($telephone)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT id, nom, prenom 
			FROM '. PREFIX .'prospect
			WHERE
				(telephone = :telephone
				OR fax = :telephone
				OR portable = :telephone)
		');
		$req->bindParam('telephone', $telephone, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function checkTelephoneClient($telephone)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT id, nom, prenom , societe
			FROM '. PREFIX .'client
			WHERE
				(telephone = :telephone
				OR fax = :telephone
				OR portable = :telephone)
		');
		$req->bindParam('telephone', $telephone, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function checkNom($nom, $table)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT id, nom, prenom , societe
			FROM '. $table .' 
			WHERE nom = :nom');
		$req->bindParam('nom', $nom, PDO::PARAM_STR);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function checkSociete($societe, $table)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT id, nom, prenom , societe
			FROM '. $table .' 
			WHERE nom = :societe');
		$req->bindParam('societe', $societe, PDO::PARAM_STR);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getMethodeContact()
	{
		$req = $GLOBALS['db']->prepare('
			SELECT *
			FROM '. PREFIX .'prospect_methode_contact
			ORDER BY nom');
		$req->execute();
		
		return $req->fetchAll();
	}
    
    public function deleteLink($id)
    {
        // Supression des prospections
        $GLOBALS['db']->exec('DELETE FROM '. PREFIX .'prospection WHERE prospect_id = '. $id);
        // Supression des suivis
        $GLOBALS['db']->exec('DELETE FROM '. PREFIX .'prospect_suivi WHERE prospect_id = '. $id);
    }
}