<?php

class modelTicket
{
	public function getAllTicket($param = '', $limit = 50, $offset = '')
	{
		$Query = "
			SELECT tt.id, titre, priorite, statut, tt.date_ajout, tc.nom, tc.prenom, tc.societe, tu.identifiant, ttc.nom as categorie, user_attrib 
			FROM ". PREFIX ."ticket tt 
			LEFT JOIN ". PREFIX ."client tc ON tt.client_id = tc.id 
			LEFT JOIN ". PREFIX ."utilisateur tu ON tt.user_id = tu.id 
			LEFT JOIN ". PREFIX ."ticket_categorie ttc ON tt.categorie_id = ttc.id";
		
		if( is_array($param) )
			$Query .= getQueryParamByArray($param);
			
		// Order by
		$Query .= " ORDER BY date_ajout DESC ";
		
		// Saisie de la limite
		$Query .= " LIMIT ". $limit;
		
		if($offset != '')
			$Query .= " OFFSET ". $offset;
			
		$req = $GLOBALS['db']->query($Query);
		return $req->fetchAll();
	}
	
	public function getTicketCategorie()
	{
		$req = $GLOBALS['db']->prepare("SELECT id, nom FROM ". PREFIX ."ticket_categorie ORDER BY nom");
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getNameClient($client_id)
	{
		$req = $GLOBALS['db']->prepare("SELECT id, nom, prenom, societe FROM ". PREFIX ."client WHERE id = :client_id LIMIT 1");
		$req->bindParam('client_id', $client_id, PDO::PARAM_INT);
		$req->execute();
		$r = $req->fetch();
		$req->closeCursor();
		return $r;
	}
	
	public function add($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'ticket')) )
		{
			if($GLOBALS['setting']['ticket_historique'] == 1)
				$this->HistoriqueAdd($GLOBALS['db']->lastInsertId(), 'Creation');
			return true;
		}
		else
			return false;
	}
	
	public function edit($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'ticket', " id = '". $data['id'] ."'")) )
		{
			if($GLOBALS['setting']['ticket_historique'] == 1)
				$this->HistoriqueAdd($data['id'], 'Edition');
			return true;
		}
		else
			return false;
	}
	
	public function delete($ticket_id)
	{
		// Supresssion du ticket
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket WHERE id = :ticket_id');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		// Supression intervention
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket_intervention WHERE ticket_id = :ticket_id');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		// Supression demande
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket_intervention_demande WHERE ticket_id = :ticket_id');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		// Suppression suivi
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket_suivi WHERE ticket_id = :ticket_id');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		// Supression des fichiers
		if( $f = getFileInDir(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $ticket_id) )
		{
			foreach($f as $k => $v)
			{
				@unlink(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $ticket_id . DS . $v);
			}
			
			@rmdir(IF_ROOT_PATH . 'upload' . DS . 'ticket' . DS . $ticket_id);
		}
	}

	public function getTicketById($ticket_id)
	{
		$req = $GLOBALS['db']->prepare("
		SELECT 
			tt.id, titre, priorite, statut, tt.date_ajout, tc.nom, tc.prenom, tc.societe, tu.identifiant, ttc.nom as categorie, tt.description, tc.nom AS nom_client, tc.prenom AS prenom_client, tc.societe AS societe_client, tt.categorie_id,
			(
				SELECT tu2.identifiant 
				FROM ". PREFIX ."utilisateur tu2 
				LEFT JOIN ". PREFIX ."ticket tt2 ON tu2.id = tt2.user_attrib 
				WHERE tu2.id = tt.user_attrib
				LIMIT 1
			) AS identifiant_attrib ,
			user_attrib 
		FROM ". PREFIX ."ticket tt 
		LEFT JOIN ". PREFIX ."client tc ON tt.client_id = tc.id 
		LEFT JOIN ". PREFIX ."utilisateur tu ON tt.user_id = tu.id 
		LEFT JOIN ". PREFIX ."ticket_categorie ttc ON tt.categorie_id = ttc.id 
		WHERE tt.id = :ticket_id 
		LIMIT 1");
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		$r = $req->fetch();
		$req->closeCursor();
		return $r;
	}
	
	public function saveAttrib($ticket_id, $user_id)
	{
		$req = $GLOBALS['db']->prepare("UPDATE ". PREFIX ."ticket SET user_attrib = :user_id WHERE id = :ticket_id");
		$req->bindParam('user_id', $user_id, PDO::PARAM_INT);
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($ticket_id, 'Attribution_du_ticket');
	}
	
	public function SuiviSave($data)
	{
		$GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'ticket_suivi') );
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($data['ticket_id'], 'Ajout_suivi');
	}
	
	public function getSuiviByTicket($ticket_id)
	{
		$req = $GLOBALS['db']->prepare("SELECT tts.id, suivi, tts.date_ajout, tu.identifiant FROM ". PREFIX ."ticket_suivi tts LEFT JOIN ". PREFIX ."utilisateur tu ON tts.user_id = tu.id WHERE ticket_id = :ticket_id ORDER BY date_ajout DESC");
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function SuiviDelete($data)
	{
		$req = $GLOBALS['db']->prepare("DELETE FROM ". PREFIX ."ticket_suivi WHERE id = :suivi_id AND ticket_id = :ticket_id");
		$req->bindParam('suivi_id', $data['suivi_id'], PDO::PARAM_INT);
		$req->bindParam('ticket_id', $data['ticket_id'], PDO::PARAM_INT);
		$req->execute();
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($data['ticket_id'], 'Supression_d_un_suivi');
	}
	
	public function getTypeIntervention()
	{
		$req = $GLOBALS['db']->prepare("SELECT id, nom, description FROM ". PREFIX ."ticket_intervention_type ORDER BY nom");
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getInterventionByTicket($ticket_id)
	{
		$req = $GLOBALS['db']->prepare('SELECT tti.id, type_id, ticket_id, tti.user_id, tti.description, tti.date_ajout, demande_id, tu.identifiant, ttit.nom AS type FROM '. PREFIX .'ticket_intervention tti LEFT JOIN '. PREFIX .'utilisateur tu ON tti.user_id = tu.id LEFT JOIN '. PREFIX .'ticket_intervention_type ttit ON tti.type_id = ttit.id WHERE ticket_id = :ticket_id ORDER BY date_ajout DESC'); 
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function InterventionSave($data)
	{
		$GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'ticket_intervention') );
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($data['ticket_id'], 'Ajout_intervention');
	}
	
	public function InterventionDelete($intervention_id)
	{
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket_intervention WHERE id = :intervention_id LIMIT 1');
		$req->bindParam('intervention_id', $intervention_id, PDO::PARAM_INT);
		$req->execute();
		
	}
	
	public function InterventionDemandeSave($data)
	{
		$GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'ticket_intervention_demande') );
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($data['ticket_id'], 'Ajout_demande_intervention');
	}
	
	public function getInterventionDemandeByTicket($ticket_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT tid.id, tid.date_ajout, description, intervention_id, tu.identifiant
			FROM '. PREFIX .'ticket_intervention_demande tid
			LEFT JOIN '. PREFIX .'utilisateur tu 
				ON tid.user_id = tu.id 
			WHERE ticket_id = :ticket_id
			AND intervention_id = 0
			ORDER BY date_ajout DESC
		');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
	
	public function InterventionDemandeDelete($demande_id)
	{
		$req = $GLOBALS['db']->prepare('DELETE FROM '. PREFIX .'ticket_intervention_demande WHERE id = :demande_id LIMIT 1');
		$req->bindParam('demande_id', $demande_id, PDO::PARAM_INT);
		$req->execute();
	}
	
	public function InterventionUpdateDemande($demande_id, $intervention_id)
	{
		$req = $GLOBALS['db']->prepare('UPDATE '. PREFIX .'ticket_intervention_demande SET intervention_id = :intervention_id WHERE id = :demande_id');
		$req->bindParam('intervention_id', $intervention_id, PDO::PARAM_INT);
		$req->bindParam('demande_id', $demande_id, PDO::PARAM_INT);
		$req->execute();
	}
	
	
	public function HistoriqueAdd($ticket_id, $action)
	{
		$req = $GLOBALS['db']->prepare('INSERT INTO '. PREFIX .'ticket_historique (ticket_id, user_id, action) VALUES (:ticket_id, :user_id, :action) ');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->bindParam('user_id', $_SESSION['utilisateur_id'], PDO::PARAM_INT);
		$req->bindParam('action', $action, PDO::PARAM_STR);
		$req->execute();
	}
	
	/**
	* @desc Supprime l attribution du ticket
	* @param int identifiant du ticket
	* */
	public function AttribDelete($ticket_id)
	{
		$req = $GLOBALS['db']->prepare('UPDATE '. PREFIX .'ticket SET user_attrib = "" WHERE id = :ticket_id');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		
		if($GLOBALS['setting']['ticket_historique'] == 1)
			$this->HistoriqueAdd($ticket_id, 'Suppression_attribution');
	}	
	
	public function getHistoriqyeByTicketId($ticket_id)
	{
		$req = $GLOBALS['db']->prepare('
			SELECT action, date_action, tu.identifiant
			FROM '. PREFIX .'ticket_historique tth
			LEFT JOIN '. PREFIX .'utilisateur tu
				ON tth.user_id = tu.id
			WHERE ticket_id = :ticket_id
			ORDER BY date_action DESC');
		$req->bindParam('ticket_id', $ticket_id, PDO::PARAM_INT);
		$req->execute();
		return $req->fetchAll();
	}
    
    public function getListeDemandeIntervention()
    {
     	$req = $GLOBALS['db']->prepare('
			SELECT tid.id, tid.date_ajout, tid.description, intervention_id, tu.identifiant, tid.ticket_id, tt.statut, tt.priorite
			FROM '. PREFIX .'ticket_intervention_demande tid
			LEFT JOIN '. PREFIX .'utilisateur tu 
				ON tid.user_id = tu.id 
            LEFT JOIN '. PREFIX .'ticket tt
                ON tid.ticket_id = tt.id
			WHERE intervention_id = 0
            AND statut < 5
			ORDER BY date_ajout DESC
		');
		$req->execute();
		return $req->fetchAll();
    }
}

/*
--- SOURCE REQUETE ---
SELECT tt.id, titre, priorite, statut, tt.date_ajout, tc.nom, tc.prenom, tc.societe, tu.identifiant, ttc.nom as categorie, tt.description, user_attrib, (SELECT tu2.identifiant FROM utilisateur tu2 INNER JOIN ticket tt2 ON tu2.id = tt2.user_attrib WHERE tu2.id = user_attrib) AS identifiant_attrib
FROM ticket tt 
INNER JOIN client tc ON tt.client_id = tc.id 
INNER JOIN utilisateur tu ON tt.user_id = tu.id
INNER JOIN ticket_categorie ttc ON tt.categorie_id = ttc.id 
WHERE tt.id = 2
*/
?>