<?php
class utilisateurModel
{
	public function getAllUser()
	{
		$req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."utilisateur ORDER BY nom,prenom,identifiant");
		$req->execute();
		return $req->fetchAll();
	}
	
	public function getUtilisateurById($id)
	{
		$req = $GLOBALS['db']->prepare("SELECT * FROM ". PREFIX ."utilisateur WHERE id = :utilisateur_id LIMIT 1");
		$req->bindParam('utilisateur_id', $id, PDO::PARAM_INT);
		$req->execute();
		$res = $req->fetch();
		$req->closeCursor();
		return $res;
	}
	
	/**
	*	@desc Verifie les donnes envoyer du formulaire pour un ajout utilisateur
	*	@return bool true|false
	* */
	public function checkAddData($data)
	{
		$error = 0;
		
		// Verification identifiant et nom
		if($data['identifiant'] == '' || $data['nom'] == '')
			$error++;
		
		// Verification identifiant libre
		if( controller::getNumberRow(PREFIX .'utilisateur', " WHERE identifiant = '". $data['identifiant'] ."'") != 0)
			$error++;
		
		// Verification Mot de passe
		if( $data['password1'] == '' || $data['password2'] == '' || $data['password1'] != $data['password2'])
			$error++;
			
		if($error == 0)
			return true;
		else
			return false;
	}
	
	public function checkUpdateData($data)
	{
		$error = 0;
		
		if( $data['nom'] == '')
			$error++;
		
		if($data['password1'] != '' && $data['password2'] != '' && $data['password1'] != $data['password2'] )
			$error++;
			
		if($data['password1'] != '' && $data['password2'] == '')
			$error++;
			
		if($data['password2'] != '' && $data['password1'] == '')
			$error++;
			
		if($error == 0)
			return true;
		else
			return false;
	}
	
	public function user_add($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryInsert($data, PREFIX . 'utilisateur')) )
			return true;
		else
			return false;
	}
	
	public function user_update($data)
	{
		if( $GLOBALS['db']->exec( CreateQueryUpdate($data, PREFIX . 'utilisateur', " id = ". $data['id'])) )
			return true;
		else
			return false;
	}
	
	public function user_delete($id)
	{
		$req = $GLOBALS['db']->prepare("DELETE FROM ". PREFIX ."utilisateur WHERE id = :utilisateur_id");
		$req->bindParam('utilisateur_id', $id, PDO::PARAM_INT);
		$req->execute();
		
		if( controller::getNumberRow(PREFIX . 'utilisateur', " WHERE id = ". $id ." ") == 0)
			return true;
		else
			return false;
	}
}